.onLoad <- function(libname, pkgname) {
  options(bigmemory.print.warning=TRUE)
  options(bigmemory.typecast.warning=TRUE)
  options(bigmemory.allow.dimnames=FALSE)
  options(bigmemory.default.type="double")
  options(bigmemory.default.shared=TRUE)
}

.onUnload <- function(libpath) {
    options(bigmemory.print.warning=NULL)
    options(bigmemory.typecast.warning=NULL)
    options(bigmemory.allow.dimnames=NULL)
    options(bigmemory.default.type=NULL)
    options(bigmemory.default.shared=NULL)
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

to_int_checked <- function(x) {
    .Call(`_bigmemory_to_int_checked`, x)
}

GetIndivMatrixElements <- function(bigMatAddr, col, row) {
    .Call(`_bigmemory_GetIndivMatrixElements`, bigMatAddr, col, row)
}

GetIndivVectorMatrixElements <- function(bigMatAddr, elems) {
    .Call(`_bigmemory_GetIndivVectorMatrixElements`, bigMatAddr, elems)
}

ReorderRIntMatrix <- function(matrixVector, nrow, ncol, orderVec) {
    invisible(.Call(`_bigmemory_ReorderRIntMatrix`, matrixVector, nrow, ncol, orderVec))
}

ReorderRNumericMatrix <- function(matrixVector, nrow, ncol, orderVec) {
    invisible(.Call(`_bigmemory_ReorderRNumericMatrix`, matrixVector, nrow, ncol, orderVec))
}

ReorderBigMatrix <- function(address, orderVec) {
    invisible(.Call(`_bigmemory_ReorderBigMatrix`, address, orderVec))
}

ReorderRIntMatrixCols <- function(matrixVector, nrow, ncol, orderVec) {
    invisible(.Call(`_bigmemory_ReorderRIntMatrixCols`, matrixVector, nrow, ncol, orderVec))
}

ReorderRNumericMatrixCols <- function(matrixVector, nrow, ncol, orderVec) {
    invisible(.Call(`_bigmemory_ReorderRNumericMatrixCols`, matrixVector, nrow, ncol, orderVec))
}

ReorderRRawMatrixCols <- function(matrixVector, nrow, ncol, orderVec) {
    invisible(.Call(`_bigmemory_ReorderRRawMatrixCols`, matrixVector, nrow, ncol, orderVec))
}

ReorderBigMatrixCols <- function(address, orderVec) {
    invisible(.Call(`_bigmemory_ReorderBigMatrixCols`, address, orderVec))
}

OrderRIntMatrix <- function(matrixVector, nrow, columns, naLast, decreasing) {
    .Call(`_bigmemory_OrderRIntMatrix`, matrixVector, nrow, columns, naLast, decreasing)
}

OrderRNumericMatrix <- function(matrixVector, nrow, columns, naLast, decreasing) {
    .Call(`_bigmemory_OrderRNumericMatrix`, matrixVector, nrow, columns, naLast, decreasing)
}

OrderBigMatrix <- function(address, columns, naLast, decreasing) {
    .Call(`_bigmemory_OrderBigMatrix`, address, columns, naLast, decreasing)
}

OrderRIntMatrixCols <- function(matrixVector, nrow, ncol, rows, naLast, decreasing) {
    .Call(`_bigmemory_OrderRIntMatrixCols`, matrixVector, nrow, ncol, rows, naLast, decreasing)
}

OrderRNumericMatrixCols <- function(matrixVector, nrow, ncol, rows, naLast, decreasing) {
    .Call(`_bigmemory_OrderRNumericMatrixCols`, matrixVector, nrow, ncol, rows, naLast, decreasing)
}

OrderBigMatrixCols <- function(address, rows, naLast, decreasing) {
    .Call(`_bigmemory_OrderBigMatrixCols`, address, rows, naLast, decreasing)
}

CCleanIndices <- function(indices, rc) {
    .Call(`_bigmemory_CCleanIndices`, indices, rc)
}

HasRowColNames <- function(address) {
    .Call(`_bigmemory_HasRowColNames`, address)
}

GetIndexRowNames <- function(address, indices_) {
    .Call(`_bigmemory_GetIndexRowNames`, address, indices_)
}

GetIndexColNames <- function(address, indices_) {
    .Call(`_bigmemory_GetIndexColNames`, address, indices_)
}

GetColumnNamesBM <- function(address) {
    .Call(`_bigmemory_GetColumnNamesBM`, address)
}

GetRowNamesBM <- function(address) {
    .Call(`_bigmemory_GetRowNamesBM`, address)
}

SetColumnNames <- function(address, columnNames) {
    invisible(.Call(`_bigmemory_SetColumnNames`, address, columnNames))
}

SetRowNames <- function(address, rowNames) {
    invisible(.Call(`_bigmemory_SetRowNames`, address, rowNames))
}

IsReadOnly <- function(bigMatAddr) {
    .Call(`_bigmemory_IsReadOnly`, bigMatAddr)
}

CIsSubMatrix <- function(bigMatAddr) {
    .Call(`_bigmemory_CIsSubMatrix`, bigMatAddr)
}

CGetNrow <- function(bigMatAddr) {
    .Call(`_bigmemory_CGetNrow`, bigMatAddr)
}

CGetNcol <- function(bigMatAddr) {
    .Call(`_bigmemory_CGetNcol`, bigMatAddr)
}

CGetType <- function(bigMatAddr) {
    .Call(`_bigmemory_CGetType`, bigMatAddr)
}

IsSharedMemoryBigMatrix <- function(bigMatAddr) {
    .Call(`_bigmemory_IsSharedMemoryBigMatrix`, bigMatAddr)
}

IsFileBackedBigMatrix <- function(bigMatAddr) {
    .Call(`_bigmemory_IsFileBackedBigMatrix`, bigMatAddr)
}

IsSeparated <- function(bigMatAddr) {
    .Call(`_bigmemory_IsSeparated`, bigMatAddr)
}

SetRowOffsetInfo <- function(bigMatAddr, rowOffset, numRows) {
    invisible(.Call(`_bigmemory_SetRowOffsetInfo`, bigMatAddr, rowOffset, numRows))
}

SetColumnOffsetInfo <- function(bigMatAddr, colOffset, numCols) {
    invisible(.Call(`_bigmemory_SetColumnOffsetInfo`, bigMatAddr, colOffset, numCols))
}

GetRowOffset <- function(bigMatAddr) {
    .Call(`_bigmemory_GetRowOffset`, bigMatAddr)
}

GetColOffset <- function(bigMatAddr) {
    .Call(`_bigmemory_GetColOffset`, bigMatAddr)
}

GetTotalColumns <- function(bigMatAddr) {
    .Call(`_bigmemory_GetTotalColumns`, bigMatAddr)
}

GetTotalRows <- function(bigMatAddr) {
    .Call(`_bigmemory_GetTotalRows`, bigMatAddr)
}

GetTypeString <- function(bigMatAddr) {
    .Call(`_bigmemory_GetTypeString`, bigMatAddr)
}

#' @title big.matrix size
#' @description Returns the size of the created matrix in bytes
#' @param bigMat a \code{big.matrix} object
#' @export
GetMatrixSize <- function(bigMat) {
    .Call(`_bigmemory_GetMatrixSize`, bigMat)
}

MWhichBigMatrix <- function(bigMatAddr, selectColumn, minVal, maxVal, chkMin, chkMax, opVal) {
    .Call(`_bigmemory_MWhichBigMatrix`, bigMatAddr, selectColumn, minVal, maxVal, chkMin, chkMax, opVal)
}

MWhichRIntMatrix <- function(matrixVector, nrow, selectColumn, minVal, maxVal, chkMin, chkMax, opVal) {
    .Call(`_bigmemory_MWhichRIntMatrix`, matrixVector, nrow, selectColumn, minVal, maxVal, chkMin, chkMax, opVal)
}

MWhichRNumericMatrix <- function(matrixVector, nrow, selectColumn, minVal, maxVal, chkMin, chkMax, opVal) {
    .Call(`_bigmemory_MWhichRNumericMatrix`, matrixVector, nrow, selectColumn, minVal, maxVal, chkMin, chkMax, opVal)
}

CCountLines <- function(fileName) {
    .Call(`_bigmemory_CCountLines`, fileName)
}

ReadMatrix <- function(fileName, bigMatAddr, firstLine, numLines, numCols, separator, hasRowNames, useRowNames) {
    .Call(`_bigmemory_ReadMatrix`, fileName, bigMatAddr, firstLine, numLines, numCols, separator, hasRowNames, useRowNames)
}

WriteMatrix <- function(bigMatAddr, fileName, rowNames, colNames, sep) {
    invisible(.Call(`_bigmemory_WriteMatrix`, bigMatAddr, fileName, rowNames, colNames, sep))
}

GetMatrixElements <- function(bigMatAddr, col, row) {
    .Call(`_bigmemory_GetMatrixElements`, bigMatAddr, col, row)
}

GetMatrixRows <- function(bigMatAddr, row) {
    .Call(`_bigmemory_GetMatrixRows`, bigMatAddr, row)
}

GetMatrixCols <- function(bigMatAddr, col) {
    .Call(`_bigmemory_GetMatrixCols`, bigMatAddr, col)
}

GetMatrixAll <- function(bigMatAddr) {
    .Call(`_bigmemory_GetMatrixAll`, bigMatAddr)
}

SetMatrixElements <- function(bigMatAddr, col, row, values) {
    invisible(.Call(`_bigmemory_SetMatrixElements`, bigMatAddr, col, row, values))
}

SetIndivVectorMatrixElements <- function(bigMatAddr, elems, inVec) {
    invisible(.Call(`_bigmemory_SetIndivVectorMatrixElements`, bigMatAddr, elems, inVec))
}

SetIndivMatrixElements <- function(bigMatAddr, col, row, values) {
    invisible(.Call(`_bigmemory_SetIndivMatrixElements`, bigMatAddr, col, row, values))
}

SetMatrixAll <- function(bigMatAddr, values) {
    invisible(.Call(`_bigmemory_SetMatrixAll`, bigMatAddr, values))
}

SetMatrixCols <- function(bigMatAddr, col, values) {
    invisible(.Call(`_bigmemory_SetMatrixCols`, bigMatAddr, col, values))
}

SetMatrixRows <- function(bigMatAddr, row, values) {
    invisible(.Call(`_bigmemory_SetMatrixRows`, bigMatAddr, row, values))
}

CreateSharedMatrix <- function(row, col, colnames, rownames, typeLength, ini, separated) {
    .Call(`_bigmemory_CreateSharedMatrix`, row, col, colnames, rownames, typeLength, ini, separated)
}

CreateLocalMatrix <- function(row, col, colnames, rownames, typeLength, ini, separated) {
    .Call(`_bigmemory_CreateLocalMatrix`, row, col, colnames, rownames, typeLength, ini, separated)
}

CreateFileBackedBigMatrix <- function(fileName, filePath, row, col, colnames, rownames, typeLength, ini, separated) {
    .Call(`_bigmemory_CreateFileBackedBigMatrix`, fileName, filePath, row, col, colnames, rownames, typeLength, ini, separated)
}

CAttachSharedBigMatrix <- function(sharedName, rows, cols, rowNames, colNames, typeLength, separated, readOnly) {
    .Call(`_bigmemory_CAttachSharedBigMatrix`, sharedName, rows, cols, rowNames, colNames, typeLength, separated, readOnly)
}

CAttachFileBackedBigMatrix <- function(fileName, filePath, rows, cols, rowNames, colNames, typeLength, separated, readOnly) {
    .Call(`_bigmemory_CAttachFileBackedBigMatrix`, fileName, filePath, rows, cols, rowNames, colNames, typeLength, separated, readOnly)
}

SharedName <- function(address) {
    .Call(`_bigmemory_SharedName`, address)
}

FileName <- function(address) {
    .Call(`_bigmemory_FileName`, address)
}

DirName <- function(address) {
    .Call(`_bigmemory_DirName`, address)
}

Flush <- function(address) {
    .Call(`_bigmemory_Flush`, address)
}

IsShared <- function(address) {
    .Call(`_bigmemory_IsShared`, address)
}

isnil <- function(address) {
    .Call(`_bigmemory_isnil`, address)
}

CDeepCopy <- function(inAddr, outAddr, rowInds, colInds, typecast_warning) {
    .Call(`_bigmemory_CDeepCopy`, inAddr, outAddr, rowInds, colInds, typecast_warning)
}

#' @useDynLib bigmemory, .registration = TRUE
#' @import methods bigmemory.sri Rcpp
#' @importFrom utils head tail

# puts an '/' at the end if there isn't
format_path <- function(path) {
  paste0(sub(file.path("", "$"), "", path), .Platform$file.sep)
}

#############################################################################
# This function is used to match up a vector of column names to the
# entire set of column names, providing the proper column indices.
# The name choice was based on the phrase "multiple map" though
# perhaps we should have made a different choice.

mmap <- function(x, y) {
  if (is.null(x)) return(NULL)
  ans <- match(x, y)
  if (any(is.na(ans))) stop("Couldn't find a match to one of the arguments.")
  return(ans)
}

checkReadOnly <- function(x)
{
  if (is.readonly(x)) {
    stop("you may not modify a read-only big.matrix object")
  }
}

#############################################################################

#' @template big.matrix_class_template
#' @export
setClass('big.matrix', representation(address='externalptr'))

#' @rdname big.matrix.descriptor-class
setClass('descriptor', representation(description='list'))

#' @template big.matrix.descriptor_class_template
#' @rdname big.matrix.descriptor-class
#' @export
setClass('big.matrix.descriptor', contains='descriptor')

# Here, x is a big.matrix, and the result is a descriptor.

# Here, x is a descriptor, and the result is the description which is
# the relevant data needed for the attach.
setGeneric('description', function(x) standardGeneric('description'))

#' @rdname attach.big.matrix
#' @export
setMethod('describe', signature(x='big.matrix'),
  function(x)
  {
    return(new('big.matrix.descriptor', description=DescribeBigMatrix(x)))
  })


#' @template core_template
#' @export
big.matrix <- function(nrow, ncol, type=options()$bigmemory.default.type,
                       init=NULL, dimnames=NULL, separated=FALSE,
                       backingfile=NULL, backingpath=NULL, descriptorfile=NULL,
                       binarydescriptor=FALSE,
                       shared=options()$bigmemory.default.shared)
{
  if (!is.null(backingfile))
  {
    if (!shared) warning("All filebacked objects are shared.")
    return(filebacked.big.matrix(nrow=nrow, ncol=ncol, type=type, init=init,
                               dimnames=dimnames, separated=separated,
                               backingfile=backingfile, backingpath=backingpath,
                               descriptorfile=descriptorfile,
                               binarydescriptor=binarydescriptor))
  }
  if (nrow < 1 | ncol < 1)
    stop('A big.matrix must have at least one row and one column')

  typeVal <- NULL
  if (type == 'integer') typeVal <- 4
  if (type == 'float') typeVal <- 6
  if (type == 'double') typeVal <- 8
  if (type == 'short') typeVal <- 2
  if (type == 'char') typeVal <- 1
  if (type == 'raw' || type == 'byte') typeVal <- 3

  if (is.null(typeVal)) stop('invalid type')
  if (!is.null(dimnames)) {
    rownames <- dimnames[[1]]
    colnames <- dimnames[[2]]
  } else {
    rownames <- NULL
    colnames <- NULL
  }
  if (is.null(init)) init <- NA
  if (shared) {
      address <- CreateSharedMatrix(as.double(nrow),
                  as.double(ncol),as.character(colnames),as.character(rownames),
                  as.integer(typeVal), as.double(init), as.logical(separated))
  } else {
    address <- CreateLocalMatrix(as.double(nrow),
                as.double(ncol), as.character(colnames), as.character(rownames),
                as.integer(typeVal), as.double(init), as.logical(separated))
  }
  if (is.null(address)) {
    stop(paste("Error: memory could not be allocated for instance",
               "of type big.matrix"))
  }
  x <- new("big.matrix", address=address)
  if (is.null(x)) {
    stop("Error encountered when creating instance of type big.matrix")
  }
  return(x)
}

#' @rdname big.matrix
#' @export
filebacked.big.matrix <- function(nrow, ncol,
                                type=options()$bigmemory.default.type,
                                init=NULL, dimnames=NULL, separated=FALSE,
                                backingfile=NULL, backingpath=NULL,
                                descriptorfile=NULL, binarydescriptor=FALSE) {

  if (nrow < 1 | ncol < 1)
    stop('A big.matrix must have at least one row and one column')

  typeVal <- NULL
  if (type == 'integer') typeVal <- 4
  if (type == 'float') typeVal <- 6
  if (type == 'double') typeVal <- 8
  if (type == 'short') typeVal <- 2
  if (type == 'char') typeVal <- 1
  if (type == 'raw' || type == 'byte') typeVal <- 3

  if (is.null(typeVal)) stop('invalid type')

  if (!is.null(dimnames)) {
    rownames <- dimnames[[1]]
    colnames <- dimnames[[2]]
  } else {
    rownames <- NULL
    colnames <- NULL
  }

  if (is.null(backingfile)) {
    stop('You must specify a backing file')
  }

  anon.backing <- ifelse( backingfile == '', TRUE, FALSE )

  if (anon.backing) {
    backingfile <- tempfile()
    backingpath <- ""
  }

  if (is.null(descriptorfile) && !anon.backing)
  {
    warning(paste("No descriptor file given, it will be named",
                  paste(backingfile, '.desc', sep='')))
    descriptorfile <- paste(backingfile, '.desc', sep='')
  }

  if ( !anon.backing && ((basename(backingfile) != backingfile) ||
       (basename(descriptorfile) != descriptorfile)) ) {
    stop(paste("The path to the descriptor and backing file are",
               "specified with the backingpath option"))
  }

  if (is.null(backingpath)) backingpath <- ''

  backingpath <- path.expand(backingpath)

  if (backingpath != "") {
    backingpath <- paste(backingpath, '', sep=.Platform$file.sep)
  }

  if(file.exists(paste(backingpath, backingfile, sep=.Platform$file.sep))){
      stop("Backing file already exists! Either remove or specify
           different backing file")
  }

  if (backingpath == "" && dirname(backingfile) == ".") {
    backingpath <- paste(getwd(), "", sep=.Platform$file.sep)
  }

  address <- CreateFileBackedBigMatrix(as.character(backingfile),
                   as.character(backingpath), as.double(nrow),
                   as.double(ncol), as.character(colnames),
                   as.character(rownames), as.integer(typeVal),
                   as.double(init), as.logical(separated))

  if (is.null(address)) {
      stop("Error encountered when creating instance of type big.matrix")
  }

  x <- new("big.matrix", address=address)

  if (is.null(x)) {
      stop("Error encountered when creating instance of type big.matrix")
  }

  if (is.null(descriptorfile) && !anon.backing) {
      warning(paste("A descriptor file has not been specified.  ",
                    "A descriptor named ", backingfile,
                    ".desc will be created.", sep=''))
      descriptorfile <- paste(backingfile, ".desc", sep='' )
  }

  if (!anon.backing) {
    descriptorfilepath <- paste(backingpath, descriptorfile,
                                sep=.Platform$file.sep)
    if(binarydescriptor) {
        saveRDS(describe(x), file=descriptorfilepath)
    } else {
        dput(describe(x), descriptorfilepath)
    }
  }
  x
}


#' @rdname big.matrix
#' @export
setGeneric('as.big.matrix',
           function(x, type=NULL, separated=FALSE,
                    backingfile=NULL, backingpath=NULL,
                    descriptorfile=NULL, binarydescriptor=FALSE,
                    shared=options()$bigmemory.default.shared) {
             standardGeneric('as.big.matrix')
           })


#' @title Convert to base R matrix
#' @description Extract values from a \code{big.matrix} object
#' and convert to a base R matrix object
#' @param x A big.matrix object
#' @export
setMethod('as.matrix', signature(x='big.matrix'),
          function(x) return(x[,]))


#' @template as.big.matrix_methods_template
NULL


setMethod('as.big.matrix', signature(x='matrix'),
          function(x, type, separated, backingfile, backingpath, descriptorfile,
                   binarydescriptor, shared)
          {
              if (!is.numeric(x) && !is.raw(x)) {
                  warning("Casting to numeric type")
                  x <- matrix(as.numeric(x), nrow=nrow(x), dimnames=dimnames(x))
              }

              if (is.null(type)) type <- typeof(x)

              if (type %in% c("integer","double", "short", "char", "float",
                              "raw")) {
                  y <- big.matrix(nrow=nrow(x), ncol=ncol(x), type=type,
                                  init=NULL, dimnames=dimnames(x),
                                  separated=separated,
                                  backingfile=backingfile,
                                  backingpath=backingpath,
                                  descriptorfile=descriptorfile,
                                  binarydescriptor=binarydescriptor,
                                  shared=shared)
                  y[seq_len(nrow(x)),seq_len(ncol(x))] <- x
                  junk <- gc()
              } else stop('bigmemory: that type is not implemented.')
              return(y)
          })



setMethod('as.big.matrix', signature(x='data.frame'),
          function(x, type, separated, backingfile, backingpath, descriptorfile,
                   binarydescriptor, shared)
          {
              warning(paste("Coercing data.frame to matrix via factor",
                            "level numberings."))
              if (is.null(type)) type <- options()$bigmemory.default.type
              if (type %in% c("integer","double", "short", "char", "raw",
                              "float")) {
                  y <- big.matrix(nrow=nrow(x), ncol=ncol(x), type=type,
                                  init=NULL, dimnames=dimnames(x),
                                  separated=separated,
                                  backingfile=backingfile,
                                  backingpath=backingpath,
                                  descriptorfile=descriptorfile,
                                  binarydescriptor=binarydescriptor,
                                  shared=shared)
                  oldbtw <- options()$bigmemory.typecast.warning
                  options(bigmemory.typecast.warning=FALSE)
                  for (i in seq_len(ncol(x))) {
                      if (is.character(x[,i])) x[,i] <- factor(x[,i])
                      if (is.factor(x[,i])) x[,i] <- as.numeric(x[,i])
                      y[,i] <- x[,i]
                  }
                  options(bigmemory.typecast.warning=oldbtw)
                  junk <- gc()
              } else stop('bigmemory: that type is not implemented.')
              return(y)

          })



setMethod('as.big.matrix', signature(x='vector'),
          function(x, type, separated, backingfile, backingpath, descriptorfile,
                   binarydescriptor, shared) {
              if (!is.numeric(x)) {
                  warning("Casting to numeric type")
                  x <- as.numeric(x)
              }
              x <- matrix(x, length(x), 1)
              warning("Coercing vector to a single-column matrix.")
              return(as.big.matrix(x, type, separated, backingfile,
                                   backingpath, descriptorfile,
                                   binarydescriptor, shared))
          })


#' @rdname big.matrix
#' @export
setGeneric('is.big.matrix', function(x) standardGeneric('is.big.matrix'))

#' @rdname big.matrix
setMethod('is.big.matrix', signature(x='big.matrix'),
  function(x) return(TRUE))

#' @rdname big.matrix
setMethod('is.big.matrix', definition=function(x) return(FALSE))

colnames.bm <- function(x) {
  ret <- GetColumnNamesBM(x@address)
  if (length(ret)==0) return(NULL)
  return(ret)
}

rownames.bm <- function(x) {
  ret <- GetRowNamesBM(x@address)
  if (length(ret)==0) return(NULL)
  return(ret)
}

assign('colnames.bm<-',
  function(x, value) {
      checkReadOnly(x)
      if (is.character(value)) {
        if (any(value=="")) {
          stop("empty strings prohibited in column names")
        }
      } else {
        if (!is.null(value)) {
          value <- as.character(value)
          warning("column names coerced to character")
        }
      }
      if (!is.null(value) & length(value) != ncol(x))
        stop("length of 'colnames' not equal to array extent.")
      SetColumnNames(x@address, value)
      return(x)
  })

assign('rownames.bm<-',
  function(x,value) {
      checkReadOnly(x)
      if (is.character(value)) {
        if (any(value=="")) {
          stop("empty strings prohibited in row names")
        }
      } else {
        if (!is.null(value)) {
          value <- as.character(value)
          warning("row names coerced to character")
        }
      }
      if (length(value) != nrow(x) & !is.null(value))
        stop("length of 'rownames' not equal to array extent.")
      SetRowNames(x@address, value)
      return(x)
  })

#' @title The Number of Rows/Columns of a big.matrix
#' @description \code{nrow} and \code{ncol} return the number of
#' rows or columns present in a \code{big.matrix} object.
#' @param x A big.matrix object
#' @return An integer of length 1
#' @docType methods
#' @rdname ncol-methods
#' @export
setMethod('ncol', signature(x="big.matrix"),
  function(x) return(CGetNcol(x@address)))

#' @rdname ncol-methods
#' @export
setMethod('nrow', signature(x="big.matrix"),
  function(x) return(CGetNrow(x@address)))

#' @title Dimensions of a big.matrix object
#' @description Retrieve the dimensions of a \code{big.matrix} object
#' @param x A \code{big.matrix} object
#' @export
setMethod('dim', signature(x="big.matrix"),
  function(x) return(c(nrow(x), ncol(x))))

#' @title Length of a big.matrix object
#' @description Get the length of a \code{big.matrix} object
#' @param x A \code{big.matrix} object
#' @export
setMethod('length', signature(x="big.matrix"),
  function(x) return(prod(dim(x))))

GetElements.bm <- function(x, i, j, drop=TRUE) {
  if (!is.numeric(i) & !is.character(i) & !is.logical(i))
    stop("row indices must be numeric, logical, or character vectors.")
  if (!is.numeric(j) & !is.character(j) & !is.logical(j))
    stop("column indices must be numeric, logical, or character vectors.")
  if (is.character(i))
    if (is.null(rownames(x))) stop("row names do not exist.")
    else i <- mmap(i, rownames(x))
  if (is.character(j))
    if (is.null(colnames(x))) stop("column names do not exist.")
    else j <- mmap(j, colnames(x))
  if (is.logical(i)) {
    if (length(i) != nrow(x))
      stop("row vector length must match the number of rows of the matrix.")
    i <- which(i)
  }
  if (is.logical(j)) {
    if (length(j) != ncol(x))
      stop(paste("column vector length must match the number of",
                 "columns of the matrix."))
    j <- which(j)
  }

  tempi <- CCleanIndices(as.double(i), as.double(nrow(x)))
  if (is.null(tempi[[1]])) stop("Illegal row index usage in extraction.\n")
  if (tempi[[1]]) i <- tempi[[2]]
  tempj <- CCleanIndices(as.double(j), as.double(ncol(x)))
  if (is.null(tempj[[1]])) stop("Illegal column index usage in extraction.\n")
  if (tempj[[1]]) j <- tempj[[2]]

  retList <- GetMatrixElements(x@address, as.double(j), as.double(i))
  mat <- .addDimnames(retList, length(i), length(j), drop)
  return(mat)
}

# Function contributed by Peter Haverty at Genentech.
GetIndivElements.bm <- function(x,i) {
  # Check i
  if (is.logical(i)) {
    stop("Logical indices not allowed when subsetting by a matrix.")
  }
  if (ncol(i) != 2) {
    stop("When subsetting with a matrix, it must have two columns.")
  }
  if (is.character(i)) {
    if (is.null(rownames(x))) stop("row names do not exist.")
    if (is.null(colnames(x))) stop("column names do not exist.")
    i <- matrix(c(mmap(i[,1], rownames(x)), mmap(i[,2], colnames(x))), ncol=2)
  }
  tempi <- CCleanIndices(as.double(i[,1]), as.double(nrow(x)))
  if (is.null(tempi[[1]])) stop("Illegal row index usage in assignment.\n")
  if (tempi[[1]]) i[,1] <- tempi[[2]]
  tempj <- CCleanIndices(as.double(i[,2]), as.double(ncol(x)))
  if (is.null(tempj[[1]])) stop("Illegal column index usage in assignment.\n")
  if (tempj[[1]]) i[,2] <- tempj[[2]]

  return(GetIndivMatrixElements(x@address, as.double(i[,2]),
                                as.double(i[,1])))
}


# Function contributed by Charles Determan Jr.
GetIndivVectorElements.bm <- function(x,i) {
  # Check i
  if (is.logical(i)) {
    stop("Logical indices not allowed when subsetting by a matrix.")
  }
  if(any(i > length(x))){
    stop("indices out of range.")
  }
  return(GetIndivVectorMatrixElements(x@address, as.integer(i)))
}

GetCols.bm <- function(x, j, drop=TRUE) {
  if (!is.numeric(j) & !is.character(j) & !is.logical(j))
    stop("column indices must be numeric, logical, or character vectors.")
  if (is.character(j))
    if (is.null(colnames(x))) stop("column names do not exist.")
    else j <- mmap(j, colnames(x))
  if (is.logical(j)) {
    if (length(j) != ncol(x))
      stop(paste("column vector length must match the number of",
                 "columns of the matrix."))
    j <- which(j)
  }

  tempj <- CCleanIndices(as.double(j), as.double(ncol(x)))
  if (is.null(tempj[[1]])) stop("Illegal column index usage in extraction.\n")
  if (tempj[[1]]) j <- tempj[[2]]

  retList <- GetMatrixCols(x@address, as.double(j))
  mat <- .addDimnames(retList, nrow(x), length(j), drop)
  return(mat)
}

GetRows.bm <- function(x, i, drop=TRUE) {
  if (!is.numeric(i) & !is.character(i) & !is.logical(i))
    stop("row indices must be numeric, logical, or character vectors.")
  if (is.character(i))
    if (is.null(rownames(x))) stop("row names do not exist.")
    else i <- mmap(i, rownames(x))
  if (is.logical(i)) {
    if (length(i) != nrow(x))
      stop("row vector length must match the number of rows of the matrix.")
    i <- which(i)
  }
  tempi <- CCleanIndices(as.double(i), as.double(nrow(x)))
  if (is.null(tempi[[1]])) stop("Illegal row index usage in extraction.\n")
  if (tempi[[1]]) i <- tempi[[2]]

  retList <- GetMatrixRows(x@address, as.double(i))
  mat <- .addDimnames(retList, length(i), ncol(x), drop)
  return(mat)
}

GetAll.bm <- function(x, drop=TRUE) {
  retList <- GetMatrixAll(x@address)
  mat <- .addDimnames(retList, nrow(x), ncol(x), drop)
  return(mat)
}

#' @title Extract or Replace
#' @description Extract or replace big.matrix elements
#' @name Extract,big.matrix
#' @param x A \code{big.matrix object}
#' @param i Indices specifying the rows
#' @param j Indices specifying the columns
#' @param drop Logical indication if reduce to minimum dimensions
#' @param value typically an array-like R object of similar class
#' @param ... Additional arguments
#' @docType methods
#' @rdname extract-methods
#' @aliases [,big.matrix,ANY,ANY,missing-method
#' @aliases [<-,big.matrix,ANY,ANY,ANY-method
#' @export
setMethod("[",
  signature(x = "big.matrix", drop = "missing"),
  function(x, i, j, drop) return(GetElements.bm(x, i, j)))


#' @rdname extract-methods
#' @export
setMethod("[",
  signature(x = "big.matrix", drop = "logical"),
  function(x, i, j, drop) return(GetElements.bm(x, i, j, drop)))


#' @rdname extract-methods
#' @export
setMethod("[",
  signature(x = "big.matrix", i="missing", drop = "missing"),
  function(x, i, j, drop) return(GetCols.bm(x, j)))


#' @rdname extract-methods
#' @export
setMethod("[",
  signature(x = "big.matrix", i="missing", drop = "logical"),
  function(x, i, j, drop) return(GetCols.bm(x, j, drop)))


#' @rdname extract-methods
#' @export
setMethod("[",
  signature(x = "big.matrix", j="missing", drop = "missing"),
  function(x, i, j, ..., drop){
    # print(nargs())
    if(nargs() == 2){
      return(GetIndivVectorElements.bm(x,i))
    }else{
      return(GetRows.bm(x, i))
    }
  })


#' @rdname extract-methods
#' @export
setMethod("[",
  signature(x = "big.matrix", j="missing", drop = "logical"),
  function(x, i, j, drop) return(GetRows.bm(x, i, drop)))


#' @rdname extract-methods
#' @export
setMethod("[",
  signature(x = "big.matrix", i="missing", j="missing", drop = "missing"),
  function(x, i, j, drop) return(GetAll.bm(x)))


#' @rdname extract-methods
#' @export
setMethod("[",
  signature(x = "big.matrix", i="missing", j="missing", drop = "logical"),
  function(x, i, j, drop) return(GetAll.bm(x, drop)))

# Function contributed by Peter Haverty at Genentech.
#' @rdname extract-methods
#' @export
setMethod('[',
  signature(x = "big.matrix",i="matrix",j="missing",drop="missing"),
  function(x, i, j, drop) return(GetIndivElements.bm(x, i)))


#' @importFrom stats na.omit
SetElements.bm <- function(x, i, j, value) {
  checkReadOnly(x)
  if (!is.numeric(i) & !is.character(i) & !is.logical(i))
    stop("row indices must be numeric, logical, or character vectors.")
  if (!is.numeric(j) & !is.character(j) & !is.logical(j))
    stop("column indices must be numeric, logical, or character vectors.")
  if (is.character(i))
    if (is.null(rownames(x))) stop("row names do not exist.")
    else i <- mmap(i, rownames(x))
  if (is.character(j))
    if (is.null(colnames(x))) stop("column names do not exist.")
    else j <- mmap(j, colnames(x))
  if (is.logical(i)) {
    if (length(i) != nrow(x))
      stop("row vector length must match the number of rows of the matrix.")
    i <- which(i)
  }
  if (is.logical(j)) {
    if (length(j) != ncol(x))
      stop(paste("column vector length must match the number of",
                 "columns of the matrix."))
    j <- which(j)
  }

  tempi <- CCleanIndices(as.double(i), as.double(nrow(x)))
  if (is.null(tempi[[1]])) stop("Illegal row index usage in assignment.\n")
  if (tempi[[1]]) i <- tempi[[2]]
  tempj <- CCleanIndices(as.double(j), as.double(ncol(x)))
  if (is.null(tempj[[1]])) stop("Illegal column index usage in assignment.\n")
  if (tempj[[1]]) j <- tempj[[2]]

  if ( options()$bigmemory.typecast.warning &&
       ((typeof(value) == "double") && (typeof(x) != "double") ||
       (typeof(value) == "integer" && (typeof(x) != "double" &&
                                           typeof(x) != "float" &&
                                           typeof(x) != "integer")) ||
       (typeof(value) == "double" && (typeof(x) == "float")) ||
       (typeof(value) == "raw" && (typeof(x) != "raw"))
       ))
  {
    warning(paste0("Assignment will down cast from ", typeof(value), " to ",
                typeof(x), "\nHint: To remove this warning type:  ",
                "options(bigmemory.typecast.warning=FALSE)\n", sep=''))
  }

  totalts <- as.double(length(i)) * as.double(length(j))
  # If we are assigning from a matrix, make sure the dimensions agree.
  if (is.matrix(value))
  {
    if (ncol(value) != length(j) || nrow(value) != length(i))
    {
      stop("Matrix dimensions do not agree with big.matrix instance set size.")
    }
  } else if (length(value) != totalts) {
    # Otherwise, make sure we are assigning the correct number of things
    # (rep if necessary)
    numReps <- totalts / length(value)
    if (numReps != round(numReps))
    {
      stop("number of items to replace is not a multiple of replacement length")
    }
  }
  switch(typeof(x),
         'double' = {SetMatrixElements(x@address, as.double(j), as.double(i), as.double(value))},
         'float' = {SetMatrixElements(x@address, as.double(j), as.double(i), as.double(value))},
         #Don't convert raw before assigning them
         'raw' = {SetMatrixElements(x@address, as.double(j), as.double(i), value)},
         SetMatrixElements(x@address, as.double(j), as.double(i), to_int_checked(value))
  )
  x
}

SetIndivElements.bm <- function(x, i, value) {
  # Check i
  checkReadOnly(x)
  if (is.logical(i)) {
    stop("Logical indices not allowed when subsetting by a matrix.")
  }
  if (ncol(i) != 2) {
    stop("When subsetting with a matrix, it must have two columns.")
  }
  if (is.character(i)) {
    if (is.null(rownames(x))) stop("row names do not exist.")
    if (is.null(colnames(x))) stop("column names do not exist.")
    i <- matrix(c(mmap(i[,1], rownames(x)), mmap(i[,2], colnames(x))), ncol=2)
  }
  tempi <- CCleanIndices(as.double(i[,1]), as.double(nrow(x)))
  if (is.null(tempi[[1]])) stop("Illegal row index usage in assignment.\n")
  if (tempi[[1]]) i[,1] <- tempi[[2]]
  tempj <- CCleanIndices(as.double(i[,2]), as.double(ncol(x)))
  if (is.null(tempj[[1]])) stop("Illegal column index usage in assignment.\n")
  if (tempj[[1]]) i[,2] <- tempj[[2]]

  # Check value length, rep as necessary
  if (length(value) > nrow(i) || nrow(i) %% length(value) != 0) {
    stop("number of items to replace is not a multiple of replacement length")
  }
  if (length(value) < nrow(i)) {
    value <- rep(value, nrow(i) %/% length(value))
  }

  # Give typecast warning if necessary
  if ( options()$bigmemory.typecast.warning &&
       ((typeof(value) == "double") && (typeof(x) != "double") ||
       (typeof(value) == "integer" &&
        (typeof(x) != "double" && typeof(x) != "integer"))) ||
       (typeof(value) == "double" && (typeof(x) == "float")) ||
  		 (typeof(value) == "raw" && (typeof(x) != "raw"))) {
    warning(cat("Assignment will down cast from ", typeof(value), " to ",
                typeof(x), "\nHint: To remove this warning type:  ",
                "options(bigmemory.typecast.warning=FALSE)\n", sep=''))
  }

  switch(typeof(x),
    'double' = {SetIndivMatrixElements(x@address, as.double(i[,2]),
                                       as.double(i[,1]), as.double(value))},
    'float' = {SetIndivMatrixElements(x@address, as.double(i[,2]),
                                      as.double(i[,1]), as.single(value))},
    #Don't convert raw before assigning them
    'raw' = {SetIndivMatrixElements(x@address, as.double(i[,2]),
  																	as.double(i[,1]), value)},
     SetIndivMatrixElements(x@address, as.double(i[,2]),
                            as.double(i[,1]), as.integer(value)))
  x
}


# Function contributed by Charles Determan Jr.
SetIndivVectorElements.bm <- function(x, i, value) {
  # Check i
  if (is.logical(i)) {
    stop("Logical indices not allowed when subsetting by a matrix.")
  }
  if(any(i > length(x))){
    stop("indices out of range.")
  }

  if(length(value) > length(i)) {
    stop("value elements longer than indices")
  }

  if(length(value) < length(i)) {
    if(length(value) != 1){
      stop("value must be of length equal to 'i' or 1")
    }
  }

  if(length(value) == 1) {
    value <- rep(value, length(i))
  }

  SetIndivVectorMatrixElements(x@address, as.integer(i), value)

  x
}

#' @importFrom stats na.omit
SetCols.bm <- function(x, j, value)
{
  checkReadOnly(x)
  if (!is.numeric(j) & !is.character(j) & !is.logical(j))
    stop("column indices must be numeric, logical, or character vectors.")
  if (is.character(j))
    if (is.null(colnames(x))) stop("column names do not exist.")
    else j <- mmap(j, colnames(x))
  if (is.logical(j)) {
    if (length(j) != ncol(x))
      stop(paste("column vector length must match the number of",
                 "columns of the matrix."))
    j <- which(j)
  }

  tempj <- CCleanIndices(as.double(j), as.double(ncol(x)))
  if (is.null(tempj[[1]])) stop("Illegal column index usage in extraction.\n")
  if (tempj[[1]]) j <- tempj[[2]]

  if ( options()$bigmemory.typecast.warning &&
       ((typeof(value) == "double") && (typeof(x) != "double") ||
       (typeof(value) == "integer" &&
        (typeof(x) != "double" && typeof(x) != "integer")) ||
       (typeof(value) == "double" && (typeof(x) == "float"))) ||
  		 (typeof(value) == "raw" && (typeof(x) != "raw"))) {
    warning(cat("Assignment will down cast from ", typeof(value), " to ",
                typeof(x), "\nHint: To remove this warning type:  ",
                "options(bigmemory.typecast.warning=FALSE)\n", sep=''))
  }

  totalts <- as.double(nrow(x)) * as.double(length(j))
  # If we are assigning from a matrix, make sure the dimensions agree.
  if (is.matrix(value)) {
    if (ncol(value) != length(j) | nrow(value) != nrow(x)) {
      stop("Matrix dimensions do not agree with big.matrix instance set size.")
    }
  }
  else if (length(value) != totalts) {
    # Otherwise, make sure we are assigning the correct number of things
    # (rep if necessary)
    numReps <- totalts / length(value)
    if (numReps != round(numReps)) {
      stop(paste("number of items to replace is not a multiple of",
                 "replacement length"))
    }
  }
  if (typeof(x) != 'double') {
    integerVals <- na.omit(as.integer(value))
    if ( sum(integerVals == na.omit(as.integer(value))) !=
         length(integerVals) | is.factor(value)) {
      warning("non-integer (possibly Inf or -Inf) typecast to integer")
    }
  }

  switch(typeof(x),
    'double' = {SetMatrixCols(x@address, as.double(j), as.double(value))},
    'float' = {SetMatrixCols(x@address, as.double(j), as.single(value))},
  	#Don't convert raw before assigning them
  	'raw' = {SetMatrixCols(x@address, as.double(j), value)},
  	SetMatrixCols(x@address, as.double(j), as.integer(value)))

  x
}

#' @importFrom stats na.omit
SetRows.bm <- function(x, i, value) {
  checkReadOnly(x)
  if (!is.numeric(i) & !is.character(i) & !is.logical(i))
    stop("row indices must be numeric, logical, or character vectors.")
  if (is.character(i))
    if (is.null(rownames(x))) stop("row names do not exist.")
    else i <- mmap(i, rownames(x))
  if (is.logical(i)) {
    if (length(i) != nrow(x)) {
      stop("row vector length must match the number of rows of the matrix.")
    }
    i <- which(i)
  }

  tempi <- CCleanIndices(as.double(i), as.double(nrow(x)))
  if (is.null(tempi[[1]])) stop("Illegal row index usage in extraction.\n")
  if (tempi[[1]]) i <- tempi[[2]]

  if ( options()$bigmemory.typecast.warning &&
       ((typeof(value) == "double") && (typeof(x) != "double") ||
       (typeof(value) == "integer" &&
        (typeof(x) != "double" && typeof(x) != "integer"))  ||
       (typeof(value) == "double" && (typeof(x) == "float"))) ||
  		 (typeof(value) == "raw" && (typeof(x) != "raw"))) {
    warning(cat("Assignment will down cast from ", typeof(value), " to ",
                typeof(x), "\nHint: To remove this warning type:  ",
                "options(bigmemory.typecast.warning=FALSE)\n", sep=''))
  }

  # Note: i may be a mwhich statement in which case we _must_ ensure
  # that we disable read locking before it is evaluated or we will
  # have a race condition.  - Jay and Mike.

  totalts <- as.double(length(i)) * as.double(ncol(x))

  # If we are assigning from a matrix, make sure the dimensions agree.
  if (is.matrix(value)) {
    if (ncol(value) != ncol(x) | nrow(value) != length(i)) {
      stop("Matrix dimensions do not agree with big.matrix instance set size.")
    }
  }
  else if (length(value) != totalts) {
    # Otherwise, make sure we are assigning the correct number of things
    # (rep if necessary)
    numReps <- totalts / length(value)
    if (numReps != round(numReps))
    {
      stop(paste("number of items to replace is not a multiple of",
                 "replacement length"))
    }
  }
  if (typeof(x) != 'double') {
    integerVals <- na.omit(as.integer(value))
    if ( sum(integerVals == na.omit(as.integer(value))) !=
         length(integerVals) | is.factor(value)) {
      warning("non-integer (possibly Inf or -Inf) typecast to integer")
    }
  }

  switch(typeof(x),
    'double' = {SetMatrixRows(x@address, as.double(i), as.double(value))},
    'float' = {SetMatrixRows(x@address, as.double(i), as.single(value))},
  	#Don't convert raw before assigning them
  	'raw' = {SetMatrixRows(x@address, as.double(i), value)},
    SetMatrixRows(x@address, as.double(i), as.integer(value)))

  x
}

#' @importFrom stats na.omit
SetAll.bm <- function(x, value) {
  checkReadOnly(x)
  if ( options()$bigmemory.typecast.warning &&
       ((typeof(value) == "double") && (typeof(x) != "double") ||
       (typeof(value) == "integer" &&
        (typeof(x) != "double" && typeof(x) != "integer"))  ||
       (typeof(value) == "double" && (typeof(x) == "float"))) ||
  		 (typeof(value) == "raw" && (typeof(x) != "raw"))) {
    warning(cat("Assignment will down cast from ", typeof(value), " to ",
                typeof(x), "\nHint: To remove this warning type:  ",
                "options(bigmemory.typecast.warning=FALSE)\n", sep=''))
  }

  totalts <- as.double(nrow(x)) * as.double(ncol(x))
  # If we are assigning from a matrix, make sure the dimensions agree.
  if (is.matrix(value)) {
    if (ncol(value) != ncol(x) | nrow(value) != nrow(x)) {
      stop("Matrix dimensions do not agree with big.matrix instance set size.")
    }
  }
  else if (length(value) != totalts) {
    # Otherwise, make sure we are assigning the correct number of things
    # (rep if necessary)
    numReps <- totalts / length(value)
    if (numReps != round(numReps)) {
      stop(paste("number of items to replace is not a multiple of",
                 "replacement length"))
    }
  }
  if (typeof(x) != 'double')
  {
    integerVals <- na.omit(as.integer(value))
    if ( sum(integerVals == na.omit(as.integer(value))) !=
         length(integerVals) | is.factor(value)) {
      warning("non-integer (possibly Inf or -Inf) typecast to integer")
    }
  }

  switch(typeof(x),
    'double' = {SetMatrixAll(x@address, as.double(value))},
    'float' = {SetMatrixAll(x@address, as.single(value))},
  	#Don't convert raw before assigning them
  	'raw' = {SetMatrixAll(x@address, value)},
  	SetMatrixAll(x@address, as.integer(value)))

  x
}

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix", i = "numeric", j = "numeric"),
  function(x, i, j, value) return(SetElements.bm(x, i, j, value)))

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix", i = "numeric", j = "logical"),
  function(x, i, j, value) return(SetElements.bm(x, i, j, value)))

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix", i = "logical", j = "numeric"),
  function(x, i, j, value) return(SetElements.bm(x, i, j, value)))

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix", i = "logical", j = "logical"),
  function(x, i, j, value) return(SetElements.bm(x, i, j, value)))

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix", i = "logical", j = "character"),
  function(x, i, j, value) {
    if (any(duplicated(j))) {
      stop("Column names can't be duplicated.")
    }
    ms <- match(j, colnames(x))
    if (any(is.na(ms))) {
      stop("Column names don't appear in the big.matrix.")
    }
    return(SetElements.bm(x, i, ms, value))
  })

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix", i = "numeric", j = "character"),
  function(x, i, j, value) {
    if (any(duplicated(j))) {
      stop("Column names can't be duplicated.")
    }
    ms <- match(j, colnames(x))
    if (any(is.na(ms))) {
      stop("Column names don't appear in the big.matrix.")
    }
    return(SetElements.bm(x, i, ms, value))
  })

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix", i = "missing", j = "missing"),
  function(x, i, j, value){
    i <- seq(nrow(x))
    j <- seq(ncol(x))
    return(SetElements.bm(x, i, j, value))
  })

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix", i="missing", j = "numeric"),
  function(x, i, j, value) return(SetCols.bm(x, j, value)))

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix", i="missing", j = "logical"),
  function(x, i, j, value) return(SetCols.bm(x, j, value)))

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix", i = "numeric", j="missing", value = "numeric"),
  function(x, i, j, ..., value){

    if (nargs() == 3){
      SetIndivVectorElements.bm(x, i, value)
    } else {
      SetRows.bm(x, i, value)
    }
  })


#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix", i = "logical", j="missing", value = "numeric"),
  function(x, i, j, ..., value){

    if (nargs() == 3) {
      SetIndivVectorElements.bm(x, i, value)
    } else {
      SetRows.bm(x, i, value)
    }
  })

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix", i = "numeric", j="missing", value = "matrix"),
  function(x, i, j, ..., value){

    if (nargs() == 3) {
      SetIndivVectorElements.bm(x, i, value)
    } else {
      SetRows.bm(x, i, value)
    }
  })

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix", i = "logical", j="missing", value = "matrix"),
  function(x, i, j, ..., value){

    if (nargs() == 3) {
      SetIndivVectorElements.bm(x, i, value)
    } else {
      SetRows.bm(x, i, value)
    }
  })

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x="big.matrix", i="character", j="character"),
  function(x, i, j, value) return(SetElements.bm(x, i, j, value)))

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x="big.matrix", i="missing", j="character"),
  function(x, j, value) return(SetCols.bm(x, j, value)))

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x="big.matrix", i="character", j="missing"),
  function(x, i, value) return(SetRows.bm(x, i, value)))

#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix", i="missing", j="missing", value = "numeric"),
  function(x, i, j, value) SetAll.bm(x, value))

# Function contributed by Peter Haverty at Genentech.
#' @rdname extract-methods
#' @export
setMethod('[<-',
  signature(x = "big.matrix",i="matrix",j="missing", value = "numeric"),
  function(x, i, j, value) SetIndivElements.bm(x, i, value))

#' @title The Type of a big.matrix Object
#' @description \code{typeof} returns the storage type of a
#' \code{big.matrix} object
#' @param x A \code{big.matrix} object
#' @export
setMethod('typeof', signature(x="big.matrix"),
  function(x) {
    GetTypeString(x@address)
  })


#' @title Check if Float
#' @description Check to see if the elements of a big.matrix object are floats.
#' @param x An object to be evaluated if float
#' @export
setGeneric('is.float', function(x) standardGeneric('is.float'))

#' @title Is Float?
#' @description Check if R numeric value has float flag
#' @param x A numeric value
setMethod('is.float', signature(x='numeric'),
  function(x){
    if (is.null(attr(x, 'Csingle'))) {
      FALSE
    } else {
      bool <- attr(x, 'Csingle')
      bool
    }
  })

#' @title Return First or Last Part of a big.matrix Object
#' @description Returns the first or last parts of a \code{big.matrix}
#' object.
#' @param x A big.matrix object
#' @param n A single integer for the number of rows to return
#' @docType methods
#' @rdname head-methods
#' @export
setMethod('head', signature(x="big.matrix"),
  function(x, n = 6) {
    n <- min(as.integer(n), nrow(x))
    if ( n < 1 | n > nrow(x) ) {
      stop("n must be between 1 and nrow(x)")
    }
    return(x[seq_len(n),])
  })


#' @rdname head-methods
#' @export
setMethod('tail', signature(x="big.matrix"),
  function(x, n = 6) {
    n <- min(as.integer(n), nrow(x))
    if ( n < 1 | n > nrow(x) ) {
      stop("n must be between 1 and nrow(x)")
    }
    return(x[(nrow(x)-n+1):nrow(x),])
  })

#' @title Print Values
#' @description \code{print} will print out the elements within
#' a \code{big.matrix} object.
#' @note By default, this will only return the \code{head} of a big.matrix
#' to prevent console overflow.  If you turn off the bigmemory.print.warning
#' option then it will convert to a base R matrix and print all elements.
#' @param x A \code{big.matrix} object
#' @export
setMethod('print', signature(x='big.matrix'),
  function(x) {
    if (options()$bigmemory.print.warning==TRUE)
    {
      cat("Warning: This is not advised.  Here is the head of the matrix:\n")
      print(head(x))
    }
    else
    {
      # Should change this to a C print function, unfortunately, for proper
      # formatting, this means we would also have to pass the terminal
      # width.
      print(x[,])
    }
  })

###################################################################
# mwhich()
#
# x big.matrix
# cols  is.numeric or is.character
# vals  list of scalar or 2-vectors otherwise
# comps could be missing, in which case we'll fill in 'eq' in signature,
#       a list of comparisons matching dim of associated vals component

#' @template mwhich_template
#' @export
setGeneric('mwhich', function(x, cols, vals, comps, op = 'AND')
  standardGeneric('mwhich'))

# add mwhich-methods roxygen
# setting to NULL avoids the redundant usage statements
#' @template mwhich_methods_template
NULL

setMethod('mwhich',
  signature(x='big.matrix', op='character'),
  function(x, cols, vals, comps, op) {
    return(mwhich.internal(x, cols, vals, comps, op, MWhichBigMatrix))
  })

# @rdname mwhich-methods
setMethod('mwhich',
  signature(x='matrix', op='character'),
  function(x, cols, vals, comps, op)
  {
    if (is.integer(x)) {
      mwhich.internal(x, cols, vals, comps, op, MWhichRIntMatrix)
    } else if (is.numeric(x)) {
      mwhich.internal(x, cols, vals, comps, op, MWhichRNumericMatrix)
    } else {
      stop("Unsupported matrix type given to mwhich")
    }
  })

# @rdname mwhich-methods
setMethod('mwhich',
  signature(x='big.matrix', op='missing'),
  function(x, cols, vals, comps)
    return(mwhich.internal(x, cols, vals, comps, op='AND',
                           whichFuncName=MWhichBigMatrix)))

# @rdname mwhich-methods
setMethod('mwhich',
  signature(x='matrix', op='missing'),
  function(x, cols, vals, comps)
  {
    if (is.integer(x))
      return(mwhich.internal(x, cols, vals, comps, op='AND',
                             whichFuncName=MWhichRIntMatrix))
    if (is.numeric(x))
      return(mwhich.internal(x, cols, vals, comps, op='AND',
                             whichFuncName=MWhichRNumericMatrix))
    stop("Unsupported matrix type given to mwhich")
  })

mwhich.internal <- function(x, cols, vals, comps, op, whichFuncName)
{
  cols <- cleanupcols(cols, ncol(x), colnames(x))
  if (length(setdiff(cols, seq_len(ncol(x)))) > 0)
    stop('Invalid column(s) in which()')

  # if vals or comps are not lists but are length 1 or 2, make them
  # trivial lists.
  if ( !is.list(vals) &
       (length(vals)==1 || length(vals)==2) ) {
    vals <- list(vals)
  } else {
    if (!is.list(vals)) stop('vals should be a list')
  }
  if ( !is.list(comps) &
       (length(comps)==1 || length(comps)==2)) {
    comps <- list(comps)
  } else {
    if (!is.list(comps)) stop('comps should be a list')
  }

  # Replicate vals or comps if appropriate.
  if (length(cols)!=length(vals)) {
    if (length(vals)==1) {
      vals <- data.frame(matrix(unlist(vals), length(vals), length(cols)))
    } else stop('length(vals) must be 1 or length(cols)')
  }
  if (length(cols)!=length(comps)) {
    if (length(comps)==1) {
      comps <- data.frame(matrix(unlist(comps), length(comps), length(cols)),
                          stringsAsFactors=FALSE)
    } else stop('length(comps) must be 1 or length(cols)')
  }
  if (length(comps)!=length(vals))
    stop('length of comps must equal length of vals')
  if (any(!unlist(lapply(comps, is.character))) ||
      any(!(unlist(comps) %in% c('eq', 'neq', 'le', 'lt', 'ge', 'gt')))) {
    stop('comps must contain eq, neq, le, lt, ge, or gt')
  }

  testCol <- cols
  opVal <- 0
  if (op == 'OR') opVal <- 1
  minVal <- rep(NA, length(cols))
  maxVal <- rep(NA, length(cols))
  chkmin <- rep(0, length(cols))
  chkmax <- rep(0, length(cols))

  for (i in seq_len(length(cols))) {

    if (length(vals[[i]])==1) {
      # Here, we have the easy comparisons.
      if (is.na(vals[[i]]) && (comps[[i]]!='eq' && comps[[i]]!='neq'))
        stop('NA comparison limited to eq and neq, not le, lt, gt, or ge')
      if (length(comps[[i]])==1) {
        if (comps[[i]]=='eq' || comps[[i]]=='neq') {
          minVal[i] <- vals[[i]]
          maxVal[i] <- vals[[i]]
        }
        if (comps[[i]]=='neq') {
          chkmin[i] <- -1
          chkmax[i] <- -1            # Not used, but....
        }
        if (comps[[i]]=='ge' || comps[[i]]=='gt') {
          minVal[i] <- vals[[i]]
          maxVal[i] <- Inf
          if (comps[[i]]=='gt') chkmin[i] <- 1
        }
        if (comps[[i]]=='le' || comps[[i]]=='lt') {
          minVal[i] <- -Inf
          maxVal[i] <- vals[[i]]
          if (comps[[i]]=='lt') chkmax[i] <- 1
        }
      } else stop('vals/comps must be componentwise of same dimension')
    } else {
      # Here, we have two vals and two comps
      if (any(is.na(vals[[i]]))) stop('NAs not allowed in interval comparison')
      minVal[i] <- vals[[i]][1]
      maxVal[i] <- vals[[i]][2]
      if (comps[[i]][1]=='gt') chkmin[i] <- 1
      if (comps[[i]][2]=='lt') chkmax[i] <- 1
      if (comps[[i]][1]!='gt' && comps[[i]][1]!='ge')
        stop('invalid comparison of lower bound')
      if (comps[[i]][2]!='lt' && comps[[i]][2]!='le')
        stop('invalid comparison of upper bound')
    }

  } # End of the for loop

  ##### The new C function has new vectors chkmin and chkmax;
  ##### the value 0 indicates comparison with equality,
  ##### the value 1 indicates a strict inequality,
  ##### the value -1 indicates a 'neq' check;
  ##### if is.na checking is required, only the minVal needs to be
  ##### used, with chkmin = 0 being is.na and chkmin = 1 being !is.na.

  ret <- NULL
  if (is.big.matrix(x)) {
    ret <- whichFuncName(x@address, as.double(testCol),
                as.double(minVal), as.double(maxVal),
                as.integer(chkmin), as.integer(chkmax), as.integer(opVal))
  } else {
    ret <- whichFuncName(x, nrow(x),
                as.double(testCol),
                as.double(minVal), as.double(maxVal),
                as.integer(chkmin), as.integer(chkmax), as.integer(opVal))
  }
  ret
}


#' @title Dimnames of a big.matrix Object
#' @description Retrieve or set the dimnames of an object
#' @param x A big.matrix object
#' @param value A possible value for \code{dimnames(x)}
#' @docType methods
#' @rdname dimnames-methods
#' @export
setMethod('dimnames', signature(x = "big.matrix"),
  function(x) return(list(rownames.bm(x), colnames.bm(x))))


#' @rdname dimnames-methods
#' @export
setMethod('dimnames<-', signature(x = "big.matrix", value='list'),
  function(x, value) {
    if (options()$bigmemory.allow.dimnames) {
      rownames.bm(x) <- value[[1]]
      colnames.bm(x) <- value[[2]]
    } else {
      stop(paste("Changing dimnames is not allowed; to override, please set",
                 "options(bigmemory.allow.dimnames=TRUE)."))
    }
    return(x)
  })


#' @template write.big.matrix_template
#' @export
setGeneric('write.big.matrix',
           function(x, filename, row.names=FALSE, col.names=FALSE, sep=",")
               standardGeneric('write.big.matrix'))

#' @rdname write.big.matrix
setMethod('write.big.matrix', signature(x='big.matrix',filename='character'),
          function(x, filename, row.names, col.names, sep)
          {
            if (is.character(row.names))
                stop("You must set the row names before writing.\n")
            if (is.character(col.names))
                stop("You must set the column names before writing.\n")
            if (row.names & !HasRowColNames(x@address)[1]) {
                row.names <- FALSE
                warning(paste("No row names exist, overriding your",
                              "row.names option.\n"))
            }
            if (col.names & !HasRowColNames(x@address)[2]) {
                col.names <- FALSE
                warning(paste("No column names exist, overriding your",
                              "col.names option.\n"))
            }
            WriteMatrix(x@address, filename, as.logical(row.names),
                        as.logical(col.names), sep)
            invisible(NULL)
          })


#' @rdname write.big.matrix
#' @export
setGeneric('read.big.matrix',
  function(filename, sep=',', header=FALSE, col.names=NULL, row.names=NULL,
           has.row.names=FALSE, ignore.row.names=FALSE, type=NA, skip=0,
           separated=FALSE, backingfile=NULL, backingpath=NULL,
           descriptorfile=NULL, binarydescriptor=FALSE, extraCols=NULL,
           shared=options()$bigmemory.default.shared)
  standardGeneric('read.big.matrix'))

#' @importFrom stats na.omit
#' @rdname write.big.matrix
setMethod('read.big.matrix', signature(filename='character'),
  function(filename, sep, header, col.names, row.names, has.row.names,
           ignore.row.names, type, skip, separated, backingfile, backingpath,
           descriptorfile, binarydescriptor, extraCols,
           shared=options()$bigmemory.default.shared) {

    if (!is.logical(header))
      stop("header argument must be logical")
    if (is.logical(col.names) || is.logical(row.names))
      stop(paste("row.names and col.names, if used, must only be vectors",
                 "of names (not logicals)."))
    if ( (header || is.character(col.names)) && is.numeric(extraCols) ) {
      stop(paste("When column names are specified, extraCols must be the names",
                 "of the extra columns."))
    }
    if (!header && is.null(col.names) && is.character(extraCols))
      stop(paste("No header and no column names were specified, so extraCols",
           "must be an integer."))
    if (!file.exists(filename))
      stop(paste("The file", filename, "could not be found"))
    headerOffset <- as.numeric(header)
    colNames <- NULL
    if (header) {
      colNames <- unlist(strsplit(
        scan(filename, what='character', skip=skip, nlines=1, sep="\n",
             quiet=TRUE), split=sep))
      colNames <- gsub("\"", "", colNames, perl=TRUE)
      colNames <- gsub("\'", "", colNames, perl=TRUE)
      if (is.na(colNames[1])) colNames <- colNames[-1]
      if (is.character(col.names)) {
        warning("Using supplied column names and skipping the header row.\n")
        colNames <- col.names
      } else {
        if (!is.null(col.names)) {
          stop(paste("Invalid header/col.names usage (col.names must be",
                     "a vector of names if used).\n"))
        }
      }
    } else {
      if (is.character(col.names)) colNames <- col.names
    }

    # Get the first line of data
    firstLine <- scan(filename, what='character', skip=(skip+headerOffset),
      nlines=1, sep="\n", quiet=TRUE)
    firstLineVals <- unlist(strsplit(firstLine, split=sep))
    numFields <- length(firstLineVals)
    firstLineVals[firstLineVals=="NA"] <- NA
    if (length(firstLineVals) < numFields) {
      firstLineVals <- c(firstLineVals, NA)
    }

    # At this point, we assume there are length(colNames) columns of data if
    # available, otherwise, figure it out.
    if (!is.null(colNames)) numCols <- length(colNames)
    else {
      numCols <- length(firstLineVals) - has.row.names
    }

    if (length(firstLineVals) - has.row.names != numCols)
      stop("Dimension mismatch between header row and first data row.\n")

    rowNames <- NULL
    if (!is.null(row.names)) {
      if (is.character(row.names)) {
        rowNames <- row.names
        ignore.row.names <- TRUE
      } else {
        stop("Invalid row.names (must be a vector of names if used).\n")
      }
    }

    if (is.na(type)) {
      type <- 'double'
      if (has.row.names) firstLineVals <- firstLineVals[-1]
      if (sum(na.omit(as.integer(firstLineVals)) ==
              na.omit(as.double(firstLineVals))) ==
            numCols ) {
        type <- 'integer'
      }
      warning(paste("Because type was not specified, we chose", type,
                    "based on the first line of data."))
    }

    lineCount <- CCountLines(filename) - skip - headerOffset
    numRows <- lineCount
    createCols <- numCols
    if (is.numeric(extraCols)) createCols <- createCols + extraCols
    if (is.character(extraCols)) {
      createCols <- createCols + length(extraCols)
      colNames <- c(colNames, extraCols)
    }

    bigMat <- big.matrix(nrow=numRows, ncol=createCols, type=type,
                         dimnames=list(rowNames, colNames), init=NULL,
                         separated=separated, backingfile=backingfile,
                         backingpath=backingpath,
                         descriptorfile=descriptorfile,
                         binarydescriptor=binarydescriptor,
                         shared=options()$bigmemory.default.shared)

    # has.row.names indicates whether or not there are row names;
    # we take ignore.row.names from the user, but pass (essentially)
    # use.row.names (which is !ignore.row.names) to C:
    ReadMatrix(
          as.character(filename),
          bigMat@address,
          as.double(skip+headerOffset),
          as.double(numRows),
          as.double(numCols),
          as.character(sep),
          as.logical(has.row.names),
          as.logical(!ignore.row.names))

    bigMat
  })


#' @rdname big.matrix
#' @export
setGeneric('is.separated', function(x) standardGeneric('is.separated'))

#' @rdname big.matrix
setMethod('is.separated', signature(x='big.matrix'),
  function(x) return(IsSeparated(x@address)))

cleanupcols <- function(cols=NULL, nc=NULL, colnames=NULL) {
  if (is.null(cols)) cols <- 1:nc
  else {
    if (!is.numeric(cols) & !is.character(cols) & !is.logical(cols))
      stop("column indices must be numeric, logical, or character vectors.")
    if (is.character(cols))
      if (is.null(colnames)) stop("column names do not exist.")
      else cols <- mmap(cols, colnames)
    if (is.logical(cols)) {
      if (length(cols) != nc)
        stop(paste("column vector length must match the number of",
                   "columns of the matrix."))
      cols <- which(cols)
    }
    tempj <- CCleanIndices(as.double(cols), as.double(nc))
    if (is.null(tempj[[1]])) stop("Illegal column index usage in extraction.\n")
    if (tempj[[1]]) cols <- tempj[[2]]
  }
  return(cols)
}

cleanuprows <- function(rows=NULL, nr=NULL, rownames=NULL) {
  if (is.null(rows)) rows <- 1:nr
  else {
    if (!is.numeric(rows) & !is.character(rows) & !is.logical(rows))
      stop("column indices must be numeric, logical, or character vectors.")
    if (is.character(rows))
      if (is.null(rownames)) stop("row names do not exist.")
      else rows <- mmap(rows, rownames)
    if (is.logical(rows)) {
      if (length(rows) != nr)
        stop(paste("row vector length must match the number of",
                   "rows of the matrix."))
      rows <- which(rows)
    }
    tempj <- CCleanIndices(as.double(rows), as.double(nr))
    if (is.null(tempj[[1]])) stop("Illegal row index usage in extraction.\n")
    if (tempj[[1]]) rows <- tempj[[2]]
  }
  return(rows)
}


#' @template deepcopy_template
#' @export
deepcopy <- function(x, cols=NULL, rows=NULL,
                     y=NULL, type=NULL, separated=NULL,
                     backingfile=NULL, backingpath=NULL,
                     descriptorfile=NULL, binarydescriptor=FALSE,
                     shared=options()$bigmemory.default.shared)
{
  cols <- cleanupcols(cols, ncol(x), colnames(x))
  rows <- cleanuprows(rows, nrow(x), rownames(x))
  if (nrow(x) > 2^31-1)
    stop(paste("Too many rows to copy at this point in time;",
               "this may be fixed in the future."))
  if (is.null(type)) type <- typeof(x)
  if (is.big.matrix(x)) {
    if (is.null(separated)) separated <- is.separated(x)
  } else {
    separated <- FALSE
  }
  if (is.null(y)) {
    y <- big.matrix(nrow=length(rows), ncol=length(cols), type=type, init=NULL,
                  dimnames=dimnames(x), separated=separated,
                  backingfile=backingfile, backingpath=backingpath,
                  descriptorfile=descriptorfile,
                  binarydescriptor=binarydescriptor, shared)
  }
  if (is.big.matrix(x) && is.big.matrix(y)) {
    CDeepCopy(x@address, y@address, as.double(rows), as.double(cols),
              getOption("bigmemory.typecast.warning"))
  } else {
    for (i in seq_len(length(cols))) y[,i] <- x[rows,cols[i]]
  }

  return(y)
}

# Following the R convention we are going to assume Unix directory
# separators '/' as opposed to the Windows convention '\'.

#' @rdname sub.big.matrix
#' @export
setGeneric('is.sub.big.matrix', function(x)
	standardGeneric('is.sub.big.matrix'))

#' @rdname sub.big.matrix
setMethod('is.sub.big.matrix', signature(x='big.matrix'),
  function(x) return(CIsSubMatrix(x@address)) )

# For now a submatrix only goes over a range of columns and a range
# of row.  This could be made more sophiticated but it would probably
# take a lot of work.

#' @template sub.big.matrix_template
#' @export
setGeneric('sub.big.matrix', function(x, firstRow=1, lastRow=NULL,
  firstCol=1, lastCol=NULL, backingpath=NULL) standardGeneric('sub.big.matrix'))


#' @rdname sub.big.matrix
setMethod('sub.big.matrix', signature(x='big.matrix'),
  function(x, firstRow, lastRow, firstCol, lastCol, backingpath)
  {
    return(sub.big.matrix(describe(x), firstRow, lastRow, firstCol, lastCol,
           backingpath))
  })

#' @rdname big.matrix.descriptor-class
#' @param x A descriptor object
#' @param firstRow the first row of the submatrix
#' @param lastRow the last row of the submatrix if not NULL
#' @param firstCol the first column of the submatrix
#' @param lastCol of the submatrix if not NULL
#' @param backingpath required path to the filebacked object, if applicable
setMethod('sub.big.matrix', signature(x='big.matrix.descriptor'),
  function( x, firstRow, lastRow, firstCol, lastCol, backingpath) {
    rowOffset <- firstRow-1
    colOffset <- firstCol-1
    rbm <- attach.resource(x, path=backingpath)
    if (is.null(lastRow)) lastRow <- nrow(rbm)
    if (is.null(lastCol)) lastCol <- ncol(rbm)
    numCols <- lastCol-firstCol+1
    numRows <- lastRow-firstRow+1
    if (colOffset < 0 || rowOffset < 0 || numCols < 1 || numRows < 1 ||
        colOffset+numCols > ncol(rbm) || rowOffset+numRows > nrow(rbm))
    {
      rm(rbm)
      stop(paste("A sub.big.matrix object could not be created",
                 "with the specified parameters"))
    }
    SetRowOffsetInfo(rbm@address,
          as.double(rowOffset + GetRowOffset(rbm@address)),
          as.double(numRows) )
    SetColumnOffsetInfo(rbm@address,
          as.double(colOffset + GetColOffset(rbm@address)),
          as.double(numCols))
    return(rbm)
  })


setMethod('description', signature(x='big.matrix.descriptor'),
  function(x) return(x@description))

DescribeBigMatrix <- function(x) {
  if (!is.filebacked(x)) {
    if (is.shared(x)) {
      list(sharedType = 'SharedMemory',
           sharedName = shared.name(x),
           totalRows = GetTotalRows(x@address),
           totalCols = GetTotalColumns(x@address),
           rowOffset = GetRowOffset(x@address),
           colOffset = GetColOffset(x@address),
           nrow=nrow(x), ncol=ncol(x),
           rowNames=rownames(x),
           colNames=colnames(x),
           type=typeof(x),
           separated=is.separated(x))
    } else {
      stop("you can't describe a non-shared big.matrix.")
    }
  } else {
    list(sharedType = 'FileBacked',
         filename = file.name(x),
         dirname = format_path(dir.name(x)), # need extra '/' on Windows
         totalRows = GetTotalRows(x@address),
         totalCols = GetTotalColumns(x@address),
         rowOffset = GetRowOffset(x@address),
         colOffset = GetColOffset(x@address),
         nrow=nrow(x), ncol=ncol(x),
         rowNames=rownames(x),
         colNames=colnames(x),
         type=typeof(x),
         separated=is.separated(x))
  }
}


#' @template attach.big.matrix_template
# @rdname attach.big.matrix
#' @export
attach.big.matrix <- function(obj, ...) {
  back <- list(...)[['backingpath']]
  if (is.null(back)) {
    attach.resource(obj, ...)
  } else {
    attach.resource(obj, path = back, ...)
  }
}

#' @rdname big.matrix.descriptor-class
#' @param obj The filename of the descriptor for a filebacked matrix,
#' assumed to be in the directory specified
#' @param ... possibly \code{path} which gives the path where the descriptor
#' and/or filebacking can be found.
#' @export
setMethod('attach.resource', signature(obj = 'character'),
  function(obj, ...) {
    path <- list(...)[['path']]

    if (is.null(path) || path == "") { # unspecified path extra argument
      fileWithPath <- path.expand(obj)
    } else {
      if (dirname(obj) != ".") { # path also specified in obj
        warning(paste("Two paths were specified in attach.resource.",
                      "The one associated with the file will be used.",
                      sep="\n"))
        fileWithPath <- path.expand(obj)
      } else {
        fileWithPath <- path.expand(file.path(path, obj))
      }
    }

    if (!file.exists(fileWithPath))
      stop( paste("The file", fileWithPath, "could not be found") )
    if (dir.exists(fileWithPath))
      stop( paste(fileWithPath, "is a directory") )

    info <- tryCatch(readRDS(fileWithPath),
                     error = function(er) dget(fileWithPath))
    if (info@description$sharedType == "FileBacked") {
      info@description$dirname <- format_path(dirname(fileWithPath))
    }

    attach.resource(info, path = NULL, ...)
  })

#' @rdname big.matrix.descriptor-class
#' @export
setMethod('attach.resource', signature(obj='big.matrix.descriptor'),
  function(obj, ...) {
    # path <- list(...)[['path']]
    info <- description(obj)
    typeLength <- NULL
    if (info$type == 'char') typeLength <- 1
    if (info$type == 'short') typeLength <- 2
    if (info$type == 'integer') typeLength <- 4
    if (info$type == 'float') typeLength <- 6
    if (info$type == 'double') typeLength <- 8
    if (info$type == 'raw' ) typeLength <- 3

    if (is.null(typeLength))
      stop('invalid type')

    readonly <- list(...)[['readonly']]
    readOnly <- `if`(is.null(readonly), FALSE, readonly)
    if (!is.logical(readOnly)) {
      stop("The readOnly argument must be of type logical")
    }

    if (info$sharedType == 'SharedMemory') {
      address <- CAttachSharedBigMatrix(as.character(info$sharedName),
        as.double(info$totalRows),
        as.double(info$totalCols),
        as.character(info$rowNames),
        as.character(info$colNames),
        as.integer(typeLength),
        as.logical(info$separated),
        as.logical(readOnly))
    } else {
      file <- file.path(info$dirname, info$filename)
      if (!info$separated) {
        if (!file.exists(file))
        {
          stop(paste("The backing file", file, "could not be found"))
        }
      } else {
        # It's separated and we need to check for each column.
        fn <- paste0(file, "_column_", 1:info$ncol - 1)
        noexists <- which(!file.exists(fn))
        if (length(noexists)) # report the first non-existing
          stop(paste("The backing file", fn[noexists[1]],
                     "could not be found"))
      }
      address <- CAttachFileBackedBigMatrix(
        as.character(info$filename),
        as.character(info$dirname),
        as.double(info$totalRows),
        as.double(info$totalCols),
        as.character(info$rowNames),
        as.character(info$colNames),
        as.integer(typeLength),
        as.logical(info$separated),
        as.logical(readOnly))
    }
    if (!is.null(address)) {
      SetRowOffsetInfo(address, info$rowOffset, info$nrow)
      SetColumnOffsetInfo(address, info$colOffset, info$ncol)
      ret <- new('big.matrix', address=address)
      # If the user did not specify read-only but the big matrix could
      # only be opened read-only then issue a warning.
      if (readOnly != is.readonly(ret)) {
        warning("big.matrix object could only be opened read-only.")
      }
    } else {
      stop("Fatal error in attach: big.matrix could not be attached.")
    }
    return(ret)
  })


#' @rdname big.matrix
#' @export
setGeneric('is.filebacked', function(x) standardGeneric('is.filebacked'))

#' @rdname big.matrix
setMethod('is.filebacked', signature(x='big.matrix'),
  function(x) return(IsFileBackedBigMatrix(x@address)))

#' @rdname big.matrix
#' @export
setGeneric('shared.name', function(x) standardGeneric('shared.name'))

#' @rdname big.matrix
setMethod('shared.name', signature(x='big.matrix'),
  function(x) return(SharedName(x@address)))

#' @rdname big.matrix
#' @export
setGeneric('file.name', function(x) standardGeneric('file.name'))

#' @rdname big.matrix
setMethod('file.name', signature(x='big.matrix'),
  function(x) {
    if (!is.filebacked(x)) {
      stop("The argument is not a file backed big.matrix.")
    }
    return(FileName(x@address))
  })

#' @rdname big.matrix
#' @export
setGeneric('dir.name', function(x) standardGeneric('dir.name'))

#' @rdname big.matrix
setMethod('dir.name', signature(x='big.matrix'),
          function(x) {
            if (!is.filebacked(x)) {
              stop("The argument is not a file backed big.matrix.")
            }
            return(DirName(x@address))
          })



#' @template flush_template
#' @export
setGeneric('flush', function(con) standardGeneric('flush'))

#' @rdname flush-methods
setMethod('flush', signature(con='big.matrix'),
  function(con) {
    if (!is.filebacked(con)) {
      warning("You cannot call flush on a non-filebacked big.matrix")
      return(invisible(TRUE))
    }
    return(invisible(Flush(con@address)))
  })


#' @rdname big.matrix
#' @export
setGeneric('is.shared', function(x) standardGeneric('is.shared'))

#' @rdname big.matrix
setMethod('is.shared', signature(x='big.matrix'),
  function(x) return(IsShared(x@address)))

#' @template morder_template
#' @export
morder <- function(x, cols, na.last=TRUE, decreasing = FALSE) {
  if (is.character(cols)) cols <- mmap( cols, colnames(x) )
  if (sum(cols > ncol(x)) > 0 | sum(cols < 1) > 0 | sum(is.na(cols) > 0))
  {
    stop("Bad column indices.")
  }

  switch(class(x)[1],
    "big.matrix"=OrderBigMatrix(x@address, as.double(cols),
                                  as.integer(na.last), as.logical(decreasing) ),
    "matrix" = switch(typeof(x),
      'integer'=OrderRIntMatrix(x, nrow(x), as.double(cols),
                                as.integer(na.last),
                                as.logical(decreasing) ),
      'double'=OrderRNumericMatrix(x, nrow(x), as.double(cols),
                                   as.integer(na.last),
                                   as.logical(decreasing) ),
      stop("Unsupported matrix value type.")),
    stop("unsupported matrix type")
  )
}

#' @rdname morder
#' @export
morderCols <- function(x, rows, na.last=TRUE, decreasing = FALSE) {
  if (is.character(rows)) rows <- mmap( rows, rownames(x) )

  if (sum(rows > nrow(x)) > 0 | sum(rows < 1) > 0 | sum(is.na(rows) > 0)) {
    stop("Bad row indices.")
  }

  switch(class(x)[1],
    "big.matrix"=OrderBigMatrixCols(x@address, as.double(rows),
                                    as.integer(na.last),
                                    as.logical(decreasing) ),
    "matrix"=switch(typeof(x),
      'integer'=OrderRIntMatrixCols(x, nrow(x), ncol(x),
                                    as.double(rows),
                                    as.integer(na.last),
                                    as.logical(decreasing) ),
      'double'=OrderRNumericMatrixCols(x, nrow(x), ncol(x),
                                       as.double(rows),
                                       as.integer(na.last),
                                       as.logical(decreasing) ),
       'raw' = OrderRIntMatrixCols(x, nrow(x), ncol(x), as.double(rows),
                                   as.integer(na.last),
                                   as.logical(decreasing) ),
        stop("Unsupported matrix value type.")),
    stop("unsupported matrix type"))
}

#' @rdname morder
#' @export
mpermute <- function(x, order=NULL, cols=NULL, allow.duplicates=FALSE, ...)
{
  if (is.null(order) && is.null(cols))
    stop("You must specify either order or cols.")

  if (!is.null(order) && !is.null(cols))
    stop("You must specify either order or cols.")

  if (!is.null(order)) {
    if (length(order) != nrow(x))
      stop("order parameter must have the same length as nrow(x)")

    if (!allow.duplicates && sum(duplicated(order)) > 0)
      stop("order parameter contains duplicated entries.")

    r <- range(order)
    if (is.na(r[1]))
      stop("order parameter contains NAs")
    if (r[1] < 1 || r[2] > nrow(x))
      stop("order parameter contains values that are out-of-range.")
  }
  else {
    order <- morder(x, cols, ...)
  }

  switch(class(x)[1],
         "big.matrix" = ReorderBigMatrix(x@address, order),
         "matrix" = switch(typeof(x),
            'integer' = ReorderRIntMatrix(x, nrow(x), ncol(x), order),
            'double' = ReorderRNumericMatrix(x, nrow(x), ncol(x), order),
         		'raw' = ReorderRIntMatrix(x, nrow(x), ncol(x), order),
         		stop("Unsupported matrix value type.")),
         stop("invalid class")
  )

  return(invisible(TRUE))

}

#' @rdname morder
#' @export
mpermuteCols <- function(x, order=NULL, rows=NULL,
                         allow.duplicates=FALSE, ...) {

  if (is.null(order) && is.null(rows))
    stop("You must specify either order or cols.")

  if (!is.null(order) && !is.null(rows))
    stop("You must specify either order or cols.")

  if (!is.null(order)) {
    if (length(order) != ncol(x))
      stop("order parameter must have the same length as ncol(x)")

    if (!allow.duplicates && sum(duplicated(order)) > 0)
      stop("order parameter contains duplicated entries.")

    r <- range(order)
    if (is.na(r[1]))
      stop("order parameter contains NAs")
    if (r[1] < 1 || r[2] > nrow(x))
      stop("order parameter contains values that are out-of-range.")
  } else {
    order <- morderCols(x, rows, ...)
  }

  switch(class(x)[1],
    "big.matrix" = {
      ReorderBigMatrixCols(x@address, order)
      SetColumnNames(x@address, colnames(x)[order])
    },
    "matrix" = {
      switch(typeof(x),
             'integer' = ReorderRIntMatrixCols(x, nrow(x), ncol(x), order),
             'raw' = ReorderRRawMatrixCols(x, nrow(x), ncol(x), order),
             'double' = ReorderRNumericMatrixCols(x, nrow(x), ncol(x), order),
             stop("Unsupported matrix value type."))
    },
    stop("unimplemented class")
  )

  invisible(TRUE)

}

#' @rdname big.matrix
#' @export
setGeneric('is.readonly', function(x) standardGeneric('is.readonly'))

#' @rdname big.matrix
setMethod('is.readonly', signature(x='big.matrix'),
  function(x) IsReadOnly(x@address))

#' @rdname big.matrix
#' @export
is.nil <- function(address) {
  if (class(address)!="externalptr") {
    stop("address is not an externalptr.")
  }
  isnil(address)
}

getCType <- function(x) {
  if (!inherits(x, "big.matrix"))
    stop("getCType takes a big.matrix as an argument.")

  CGetType(x@address)
}

.addDimnames <- function(retList, nrow, ncol, drop) {
  if (drop && !is.matrix(retList[[1]]) ) {
    if (length(retList[[1]]) > 1) {
      if (ncol == 1) {
        thesenames <- retList[[2]]
      } else if (nrow == 1)
        thesenames <- retList[[3]]
    } else {
      thesenames <- NULL
    }
    if (!is.null(thesenames)) {
      names(retList[[1]]) <- thesenames
    }
  } else {
    if (!is.matrix(retList[[1]])) { dim(retList[[1]]) <- c(nrow, ncol) }
    if (!is.null(retList[[2]]) || !is.null(retList[[3]])) {
      dimnames(retList[[1]]) <- list( retList[[2]], retList[[3]] )
    }
  }
  return(retList[[1]])
}

library("bigmemory")
context("backingpath option when attaching")

tmp <- tempfile()
tmp.dir <- dirname(tmp)
tmp.file <- basename(tmp)
desc.path <- paste0(tmp.file, ".desc")
X <- big.matrix(10, 10, backingfile = tmp.file, backingpath = tmp.dir,
                descriptorfile = desc.path, init = 0)
X.desc <- describe(X)

test_that("Format_path puts an '/' at the end if there isn't", {
  expect_equal(format_path("test"), "test/")
  expect_equal(format_path("test/"), "test/")
  expect_equal(format_path("test/test/"), "test/test/")
})

test_that("New element 'dirname' in description", {
  expect_equal(X.desc@description$dirname, format_path(tmp.dir))
})

test_that("you can attach from a full path", {
  X2 <- attach.big.matrix(file.path(tmp.dir, desc.path))
  expect_false(is.nil(X2@address), info = "the matrix exists")
  X2[] <- 1
  expect_equal(X[,], matrix(1, 10, 10), 
               info = "modifying X2 modifies also X")
})

test_that("you can attach from a composed path", {
  X3 <- attach.big.matrix(desc.path, backingpath = tmp.dir)
  expect_false(is.nil(X3@address), info = "the matrix exists")
  X3[] <- 2
  expect_equal(X[,], matrix(2, 10, 10), 
               info = "modifying X3 modifies also X")
})

test_that("you can attach with or without backingpath", {
  X4 <- attach.big.matrix(X.desc)
  expect_false(is.nil(X4@address), info = "the matrix exists")
  X4[] <- 3
  expect_equal(X[,], matrix(3, 10, 10), 
               info = "modifying X4 modifies also X")
  X5 <- attach.big.matrix(X.desc, backingpath = tmp.dir)
  expect_false(is.nil(X5@address), info = "the matrix exists")
  X5[] <- 4
  expect_equal(X[,], matrix(4, 10, 10), 
               info = "modifying X5 modifies also X")
})

test_that("you can sub with or without backingpath", {
  X6 <- sub.big.matrix(X.desc, lastCol = 5)
  expect_false(is.nil(X6@address), info = "the matrix exists")
  X6[] <- 1
  expect_equal(X[,], cbind(matrix(1, 10, 5), matrix(4, 10, 5)), 
               info = "modifying X6 modifies also X")
  X7 <- sub.big.matrix(X.desc, firstCol = 6, backingpath = tmp.dir)
  expect_false(is.nil(X7@address), info = "the matrix exists")
  X7[] <- 2
  expect_equal(X[,], cbind(matrix(1, 10, 5), matrix(2, 10, 5)), 
               info = "modifying X7 modifies also X")
})

library("bigmemory")
context("mwhich")

# global objects
x <- as.big.matrix(matrix(1:30, 10, 3))
options(bigmemory.allow.dimnames=TRUE)
colnames(x) <- c("A", "B", "C")

x1 <- x[mwhich(x, 1:2, list(c(2,3), c(11,17)),
               list(c('ge','le'), c('gt', 'lt')), 'OR'),]
x2 <- x[mwhich(x, c("A","B"), list(c(2,3), c(11,17)), 
               list(c('ge','le'), c('gt', 'lt')), 'AND'),]

y <- matrix(1:30, 10, 3)
colnames(y) <- c("A", "B", "C")
y1 <- y[mwhich(y, 1:2, list(c(2,3), c(11,17)),
               list(c('ge','le'), c('gt', 'lt')), 'OR'),]

y2 <- y[mwhich(y, -3, list(c(2,3), c(11,17)),
               list(c('ge','le'), c('gt', 'lt')), 'AND'),]

test_that("mwhich indices correct",{
    expect_identical(x[2:6,], x1)
    expect_identical(x[2:3,], x2)
})

test_that("mwhich works for regular 'matrix'",{
    expect_identical(y1, x1)
    expect_identical(y2, x2)
})

test_that("mwhich recognizes NA", {
    x[1,1] <- NA
    expect_identical(mwhich(x, 1:2, NA, 'eq', 'OR'), 1)
    expect_identical(mwhich(x, 1:2, NA, 'neq', 'AND'), as.numeric(2:10))
})

test_that("mwhich recognizes Inf",{
    x <- big.matrix(4, 2, init=1, type="double")
    x[1,1] <- Inf
    mwhich(x, 1, Inf, 'eq')
    mwhich(x, 1, 1, 'gt')
    mwhich(x, 1, 1, 'le')
})

library("bigmemory")
context("shared option")

X1 <- big.matrix(10, 10)

opt.save <- options(bigmemory.default.shared=FALSE)
X2 <- big.matrix(10, 10)
options(opt.save)

test_that("Default shared parameter is read from options",{
  expect_true(is.shared(X1))
  expect_false(is.shared(X2))
})

library("bigmemory")
context("raw data")

m<-big.matrix(10,1,type='raw')
f<-big.matrix(10,1,type='raw',backingpath = tempfile(fileext = '.bin'))

test_that("Reading and writing byte<128 on memory-backed file",{
  m[3,1]<-as.raw(10)
  expect_equal(m[3,1],as.raw(10))
})

test_that("Reading and writing byte>=128 on memory-backed file",{
  m[4,1]<-as.raw(130)
  expect_equal(m[4,1],as.raw(130))
})

test_that("Reading and writing byte<128 on file-backed file",{
  f[5,1]<-as.raw(10)
  expect_equal(f[5,1],as.raw(10))
})

test_that("Reading and writing byte>=128 on memory-backed file",{
  f[6,1]<-as.raw(130)
  expect_equal(f[6,1],as.raw(130))
})

test_that("Making sure the 'char' matrix behaves like signed byte", {
  mchar<-big.matrix(3,1,type='char')
  mchar[1,1]<-   40
  mchar[2,1]<- -123
  mchar[3,1]<-  190
  expect_equal(mchar[1:3,1],c(40,-123,NA))
  
})

test_that("Testing for as.big.matrix for raw", {
  x <- matrix(as.raw(seq(0,255, length.out = 16)), 4, 4)
  expect_equal(typeof(x), 'raw')
  expect_equal(class(x)[1], 'matrix')
  m<-as.big.matrix(x, type = "raw")
  expect_equal(x[1,], as.raw(c(0,68,136,204)))
})

library("bigmemory")
context("big.matrix float type")

options(bigmemory.typecast.warning=FALSE)

set.seed(123)
z <- filebacked.big.matrix(3, 3, type='float', init=123.0,
                           backingfile="example.bin",
                           descriptorfile="example.desc",
                           dimnames=list(c('a','b','c'), c('d', 'e', 'f')))

mat <- matrix(1:9, ncol = 3, nrow = 3, dimnames = list(letters[1:3], 
                                                       LETTERS[1:3]))

dmat <- matrix(rnorm(9), ncol = 3, nrow = 3, dimnames = list(letters[1:3], 
                                                       LETTERS[1:3]))

fmat <- big.matrix(3,3, type="float", init = 13.123)

bm <- as.big.matrix(dmat, type="float")


test_that("filebacked matrix created successfully",{
    expect_true(file.exists("example.bin"))
    expect_true(file.exists("example.desc"))
    expect_true(all(z[,] == 123.0))
    expect_true(typeof(z) == "float")
})

test_that("RAM matrix created successfully",{
    expect_equal(bm[,], dmat, tolerance = 1e-7)
    expect_true(typeof(bm) == "float")
})

test_that("Able to access and assign elements", {
    fmat[1,3] <- 15.123
    expect_equivalent(fmat[1,3], 15.123)
    
    newRow <- rnorm(3)
    fmat[1,] <- newRow    
    expect_equal(fmat[1,], newRow, tolerance = 1e-07)

    newCol <- rnorm(3)
    fmat[,1] <- newCol
    expect_equal(fmat[,1], newCol, tolerance = 1e-07)
})

# Float data types are not typical in R
# The default warning is a sanity check to realize that
# any double (i.e. numeric) values passed are down cast to float
options(bigmemory.typecast.warning=TRUE)
test_that("Proper warning returned", {
    expect_warning(as.big.matrix(dmat, type="float"), info="Not warning about
                   float type downcast")
})

rm(z)
gc()
file.remove('example.bin')
file.remove('example.desc')

#' Manage massive matrices with shared memory and memory-mapped files.
#' 
#' Create, store, access, and manipulate massive matrices.  Matrices are, by
#' default, allocated to shared memory and may use memory-mapped files.
#' Packages \pkg{biganalytics}, \pkg{synchronicity}, \pkg{bigalgebra}, and
#' \pkg{bigtabulate} provide advanced functionality.  Access to and
#' manipulation of a \code{\link{big.matrix}} object is exposed in an S4
#' class whose interface is similar to that of a \code{\link{matrix}}.  Use of
#' these packages in parallel environments can provide substantial speed and
#' memory efficiencies.  \pkg{bigmemory} also provides a \acronym{C++}
#' framework for the development of new tools that can work both with
#' \code{big.matrix} and native \code{matrix} objects.
#' 
#' Index of functions/methods (grouped in a friendly way): \preformatted{
#' big.matrix, filebacked.big.matrix, as.big.matrix
#' 
#' is.big.matrix, is.separated, is.filebacked
#' 
#' describe, attach.big.matrix, attach.resource
#' 
#' sub.big.matrix, is.sub.big.matrix
#' 
#' dim, dimnames, nrow, ncol, print, head, tail, typeof, length
#' 
#' read.big.matrix, write.big.matrix
#' 
#' mwhich
#' 
#' morder, mpermute
#' 
#' deepcopy
#' 
#' flush }
#' 
#' Multi-gigabyte data sets challenge and frustrate users, even on
#' well-equipped hardware. Use of \acronym{C/C++} can provide efficiencies, but
#' is cumbersome for interactive data analysis and lacks the flexibility and
#' power of 's rich statistical programming environment.  The package
#' \pkg{bigmemory} and associated packages \pkg{biganalytics}, 
#' \pkg{synchronicity}, \pkg{bigtabulate}, and \pkg{bigalgebra} bridge 
#' this gap, implementing massive matrices and supporting their manipulation 
#' and exploration. The data
#' structures may be allocated to shared memory, allowing separate processes on
#' the same computer to share access to a single copy of the data set.  The
#' data structures may also be file-backed, allowing users to easily manage and
#' analyze data sets larger than available RAM and share them across nodes of a
#' cluster. These features of the Bigmemory Project open the door for powerful
#' and memory-efficient parallel analyses and data mining of massive data sets.
#' 
#' This project (\pkg{bigmemory} and its sister packages) is still actively
#' developed, although the design and current features can be viewed as
#' "stable."  Please feel free to email us with any questions:
#' bigmemoryauthors@gmail.com.
#' 
#' @name bigmemory-package
#' @aliases bigmemory-package bigmemory
#' @docType package
#' @note Various options are available.
#' \code{options(bigmemory.typecast.warning)} can be set to avoid annoying
#' warnings that might occur if, for example, you assign objects (typically
#' type double) to char, short, or integer \code{\link{big.matrix}} objects.
#' \code{options(bigmemory.print.warning)} protects against extracting and
#' printing a massive matrix (which would involve the creation of a second
#' massive copy of the matrix). \code{options(bigmemory.allow.dimnames)} by
#' default prevents the setting of \code{dimnames} attributes, because they
#' aren't allocated to shared memory and changes will not be visible across
#' processes. \code{options(bigmemory.default.type)} is \code{"double"} be
#' default (a change in default behavior as of 4.1.1) but may be changed by the
#' user.
#' 
#' Note that you can't simply use a \code{big.matrix} with many (most) existing
#' functions (e.g. \code{\link{lm}}, \code{\link{kmeans}}).  One nice exception
#' is \code{\link{split}}, because this function only accesses subsets of the
#' matrix.
#' 
#' @section Memory considerations:
#' 
#' For obvious reasons memory that the \code{big.matrix} uses is managed outside 
#' the R memory pool available to the garbage collector and the memory occupied 
#' by the \code{big.matrix} is not visible to the R.
#' This has subtle implications:
#' 
#' \itemize{
#' \item Memory usage is not visible via general R functions (e.g. the \code{gc()} function)
#' \item Garbage collector is mislead by the very small memory footprint of the \code{big.matrix}
#'       object (which acts merely as a pointer to the external memory structure), which can result
#'       in much less eagerness to garbage-collect the unused \code{big.memory} objects. 
#'       After removing a last reference to a big \code{big.matrix}, user should manually run 
#'       \code{gc()} to reclaim the memory.
#' \item Attaching the description of already finalized \code{big.matrix} and accessing this object
#'       will result in undefined behavior, which simply means it will crash the current R session
#'       with no hope of saving the data in it. To prevent R from de-allocating (finalizing) the 
#'       matrices, user should keep at least one \code{big.memory} object somewhere in R memory in at
#'       least one R session on the current machine.
#' \item Abruptly closed R (using e.g. task manager) will not have a chance to finalize the 
#'       \code{big.matrix} objects, which will result in a memory leak, as the \code{big.matrices} 
#'       will remain in the memory (perhaps under obfuscated names) with no easy way to reconnect R to them. 
#' 
#' } 
#' 
#' @author Michael J. Kane, John W. Emerson, Peter Haverty, and Charles Determan Jr.
#' 
#' Maintainers: Michael J. Kane bigmemoryauthors@gmail.com
#' @seealso For example, \code{\link{big.matrix}}, \code{\link{mwhich}},
#' \code{\link{read.big.matrix}}
#'
#' @keywords package
#' @examples
#' 
#' 
#' # Our examples are all trivial in size, rather than burning huge amounts
#' # of memory.
#' 
#' x <- big.matrix(5, 2, type="integer", init=0,
#'                 dimnames=list(NULL, c("alpha", "beta")))
#' x
#' x[1:2,]
#' x[,1] <- 1:5
#' x[,"alpha"]
#' colnames(x)
#' options(bigmemory.allow.dimnames=TRUE)
#' colnames(x) <- NULL
#' x[,]
#' 
#' 
NULL

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\docType{methods}
\name{ncol,big.matrix-method}
\alias{ncol,big.matrix-method}
\alias{nrow,big.matrix-method}
\title{The Number of Rows/Columns of a big.matrix}
\usage{
\S4method{ncol}{big.matrix}(x)

\S4method{nrow}{big.matrix}(x)
}
\arguments{
\item{x}{A big.matrix object}
}
\value{
An integer of length 1
}
\description{
\code{nrow} and \code{ncol} return the number of
rows or columns present in a \code{big.matrix} object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\name{write.big.matrix}
\alias{write.big.matrix}
\alias{write.big.matrix,big.matrix,character-method}
\alias{read.big.matrix}
\alias{read.big.matrix,character-method}
\title{File interface for a ``big.matrix''}
\usage{
write.big.matrix(x, filename, row.names = FALSE, col.names = FALSE, sep = ",")

\S4method{write.big.matrix}{big.matrix,character}(x, filename, row.names = FALSE, col.names = FALSE, sep = ",")

read.big.matrix(
  filename,
  sep = ",",
  header = FALSE,
  col.names = NULL,
  row.names = NULL,
  has.row.names = FALSE,
  ignore.row.names = FALSE,
  type = NA,
  skip = 0,
  separated = FALSE,
  backingfile = NULL,
  backingpath = NULL,
  descriptorfile = NULL,
  binarydescriptor = FALSE,
  extraCols = NULL,
  shared = options()$bigmemory.default.shared
)

\S4method{read.big.matrix}{character}(
  filename,
  sep = ",",
  header = FALSE,
  col.names = NULL,
  row.names = NULL,
  has.row.names = FALSE,
  ignore.row.names = FALSE,
  type = NA,
  skip = 0,
  separated = FALSE,
  backingfile = NULL,
  backingpath = NULL,
  descriptorfile = NULL,
  binarydescriptor = FALSE,
  extraCols = NULL,
  shared = options()$bigmemory.default.shared
)
}
\arguments{
\item{x}{a \code{\link{big.matrix}}.}

\item{filename}{the name of an input/output file.}

\item{row.names}{a vector of names, use them even if row names appear to
exist in the file.}

\item{col.names}{a vector of names, use them even if column names exist
in the file.}

\item{sep}{a field delimiter.}

\item{header}{if \code{TRUE}, the first line (after a possible skip)
should contain column names.}

\item{has.row.names}{if \code{TRUE}, then the first column contains row
names.}

\item{ignore.row.names}{if \code{TRUE} when \code{has.row.names==TRUE},
the row names will be ignored.}

\item{type}{preferably specified, \code{"integer"} for example.}

\item{skip}{number of lines to skip at the head of the file.}

\item{separated}{use separated column organization of the data instead of
column-major organization.}

\item{backingfile}{the root name for the file(s) for the cache of \code{x}.}

\item{backingpath}{the path to the directory containing the file backing
cache.}

\item{descriptorfile}{the file to be used for the description of the
filebacked matrix.}

\item{binarydescriptor}{the flag to specify if the binary RDS format should
be used for the backingfile description, for subsequent use with
\code{\link{attach.big.matrix}}; if \code{NULL} of \code{FALSE}, the
\code{dput()} file format is used.}

\item{extraCols}{the optional number of extra columns to be appended to the
matrix for future use.}

\item{shared}{if \code{TRUE}, the resulting \code{big.matrix} can be shared
across processes.}
}
\value{
a \code{\link{big.matrix}} object is returned by \code{read.big.matrix},
while \code{write.big.matrix} creates an output file (a path could be part
of \code{filename}).
}
\description{
Create a \code{\link{big.matrix}} by reading from a
suitably-formatted ASCII file, or
write the contents of a \code{\link{big.matrix}} to a file.
}
\details{
Files must contain only one atomic type
(all \code{integer}, for example).  You, the user, should know whether
your file has row and/or column names, and various combinations of options
should be helpful in obtaining the desired behavior.

When reading from a file, if \code{type} is not specified we try to
make a reasonable guess for you without
making any guarantees at this point.
Unless you have really large integer values, we recommend
you consider \code{"short"}.  If you have something that is essentially
categorical, you might even be able use \code{"char"}, with huge memory
savings for large data sets.

Any non-numeric entry will be ignored and replaced with \code{NA},
so reading something that traditionally would be a \code{data.frame}
won't cause an error.  A warning is issued.

Wishlist: we'd like to provide an option to ignore specified columns while
doing reads.
Or perhaps to specify columns targeted for factor or character conversion
to numeric values.  Would you use such features?  Email us and let us know!
}
\examples{
# Without specifying the type, this big.matrix x will hold integers.

x <- as.big.matrix(matrix(1:10, 5, 2))
x[2,2] <- NA
x[,]
temp_dir = tempdir()
if (!dir.exists(temp_dir)) dir.create(temp_dir)
write.big.matrix(x, file.path(temp_dir, "foo.txt"))

# Just for fun, I'll read it back in as character (1-byte integers):
y <- read.big.matrix(file.path(temp_dir, "foo.txt"), type="char")
y[,]

# Other examples:
w <- as.big.matrix(matrix(1:10, 5, 2), type='double')
w[1,2] <- NA
w[2,2] <- -Inf
w[3,2] <- Inf
w[4,2] <- NaN
w[,]
write.big.matrix(w, file.path(temp_dir, "bar.txt"))
w <- read.big.matrix(file.path(temp_dir, "bar.txt"), type="double")
w[,]
w <- read.big.matrix(file.path(temp_dir, "bar.txt"), type="short")
w[,]

# Another example using row names (which we don't like).
x <- as.big.matrix(as.matrix(iris), type='double')
rownames(x) <- as.character(1:nrow(x))
head(x)
write.big.matrix(x, file.path(temp_dir, 'IrisData.txt'), col.names=TRUE, 
                 row.names=TRUE)
y <- read.big.matrix(file.path(temp_dir, "IrisData.txt"), header=TRUE, 
                     has.row.names=TRUE)
head(y)

# The following would fail with a dimension mismatch:
if (FALSE) y <- read.big.matrix(file.path(temp_dir, "IrisData.txt"), 
                                header=TRUE)
}
\seealso{
\code{\link{big.matrix}}
}
\author{
John W. Emerson and Michael J. Kane
\email{<bigmemoryauthors@gmail.com>}
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\docType{methods}
\name{as.big.matrix-methods}
\alias{as.big.matrix-methods}
\alias{as.big.matrix,matrix-method}
\alias{as.big.matrix,vector-method}
\alias{as.big.matrix,data.frame-method}
\title{Create a ``big.matrix'' from a matrix or vector.}
\description{
Create a \code{\link{big.matrix}} from a \code{matrix} or \code{vector}
or \code{\link{data.frame}};
a \code{vector} will result in a \code{\link{big.matrix}} with one column.
A data frame will have character vectors converted to factors, and then
all factors converted to numeric factor levels.  All labels or character
values will be lost.
}
\section{Methods}{

\describe{
\item{\code{signature(x = "matrix")}}{ ... }
\item{\code{signature(x = "vector")}}{ ... }
\item{\code{signature(x = "data.frame")}}{ ... }
}
}

\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\name{is.float,numeric-method}
\alias{is.float,numeric-method}
\title{Is Float?}
\usage{
\S4method{is.float}{numeric}(x)
}
\arguments{
\item{x}{A numeric value}
}
\description{
Check if R numeric value has float flag
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hello-bigmemory.R
\docType{package}
\name{bigmemory-package}
\alias{bigmemory-package}
\alias{bigmemory}
\title{Manage massive matrices with shared memory and memory-mapped files.}
\description{
Create, store, access, and manipulate massive matrices.  Matrices are, by
default, allocated to shared memory and may use memory-mapped files.
Packages \pkg{biganalytics}, \pkg{synchronicity}, \pkg{bigalgebra}, and
\pkg{bigtabulate} provide advanced functionality.  Access to and
manipulation of a \code{\link{big.matrix}} object is exposed in an S4
class whose interface is similar to that of a \code{\link{matrix}}.  Use of
these packages in parallel environments can provide substantial speed and
memory efficiencies.  \pkg{bigmemory} also provides a \acronym{C++}
framework for the development of new tools that can work both with
\code{big.matrix} and native \code{matrix} objects.
}
\details{
Index of functions/methods (grouped in a friendly way): \preformatted{
big.matrix, filebacked.big.matrix, as.big.matrix

is.big.matrix, is.separated, is.filebacked

describe, attach.big.matrix, attach.resource

sub.big.matrix, is.sub.big.matrix

dim, dimnames, nrow, ncol, print, head, tail, typeof, length

read.big.matrix, write.big.matrix

mwhich

morder, mpermute

deepcopy

flush }

Multi-gigabyte data sets challenge and frustrate users, even on
well-equipped hardware. Use of \acronym{C/C++} can provide efficiencies, but
is cumbersome for interactive data analysis and lacks the flexibility and
power of 's rich statistical programming environment.  The package
\pkg{bigmemory} and associated packages \pkg{biganalytics},
\pkg{synchronicity}, \pkg{bigtabulate}, and \pkg{bigalgebra} bridge
this gap, implementing massive matrices and supporting their manipulation
and exploration. The data
structures may be allocated to shared memory, allowing separate processes on
the same computer to share access to a single copy of the data set.  The
data structures may also be file-backed, allowing users to easily manage and
analyze data sets larger than available RAM and share them across nodes of a
cluster. These features of the Bigmemory Project open the door for powerful
and memory-efficient parallel analyses and data mining of massive data sets.

This project (\pkg{bigmemory} and its sister packages) is still actively
developed, although the design and current features can be viewed as
"stable."  Please feel free to email us with any questions:
bigmemoryauthors@gmail.com.
}
\note{
Various options are available.
\code{options(bigmemory.typecast.warning)} can be set to avoid annoying
warnings that might occur if, for example, you assign objects (typically
type double) to char, short, or integer \code{\link{big.matrix}} objects.
\code{options(bigmemory.print.warning)} protects against extracting and
printing a massive matrix (which would involve the creation of a second
massive copy of the matrix). \code{options(bigmemory.allow.dimnames)} by
default prevents the setting of \code{dimnames} attributes, because they
aren't allocated to shared memory and changes will not be visible across
processes. \code{options(bigmemory.default.type)} is \code{"double"} be
default (a change in default behavior as of 4.1.1) but may be changed by the
user.

Note that you can't simply use a \code{big.matrix} with many (most) existing
functions (e.g. \code{\link{lm}}, \code{\link{kmeans}}).  One nice exception
is \code{\link{split}}, because this function only accesses subsets of the
matrix.
}
\section{Memory considerations}{


For obvious reasons memory that the \code{big.matrix} uses is managed outside
the R memory pool available to the garbage collector and the memory occupied
by the \code{big.matrix} is not visible to the R.
This has subtle implications:

\itemize{
\item Memory usage is not visible via general R functions (e.g. the \code{gc()} function)
\item Garbage collector is mislead by the very small memory footprint of the \code{big.matrix}
object (which acts merely as a pointer to the external memory structure), which can result
in much less eagerness to garbage-collect the unused \code{big.memory} objects.
After removing a last reference to a big \code{big.matrix}, user should manually run
\code{gc()} to reclaim the memory.
\item Attaching the description of already finalized \code{big.matrix} and accessing this object
will result in undefined behavior, which simply means it will crash the current R session
with no hope of saving the data in it. To prevent R from de-allocating (finalizing) the
matrices, user should keep at least one \code{big.memory} object somewhere in R memory in at
least one R session on the current machine.
\item Abruptly closed R (using e.g. task manager) will not have a chance to finalize the
\code{big.matrix} objects, which will result in a memory leak, as the \code{big.matrices}
will remain in the memory (perhaps under obfuscated names) with no easy way to reconnect R to them.

}
}

\examples{


# Our examples are all trivial in size, rather than burning huge amounts
# of memory.

x <- big.matrix(5, 2, type="integer", init=0,
                dimnames=list(NULL, c("alpha", "beta")))
x
x[1:2,]
x[,1] <- 1:5
x[,"alpha"]
colnames(x)
options(bigmemory.allow.dimnames=TRUE)
colnames(x) <- NULL
x[,]


}
\seealso{
For example, \code{\link{big.matrix}}, \code{\link{mwhich}},
\code{\link{read.big.matrix}}
}
\author{
Michael J. Kane, John W. Emerson, Peter Haverty, and Charles Determan Jr.

Maintainers: Michael J. Kane bigmemoryauthors@gmail.com
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\docType{methods}
\name{flush}
\alias{flush}
\alias{flush,big.matrix-method}
\title{Updating a big.matrix filebacking.}
\usage{
flush(con)

\S4method{flush}{big.matrix}(con)
}
\arguments{
\item{con}{filebacked \code{\link{big.matrix}}.}
}
\value{
\code{TRUE} or \code{FALSE} (invisible), indicating whether or not the flush was successful.
}
\description{
For a file-backed \code{big.matrix} object, \code{flush()} forces
any modified information to be written to the file-backing.
}
\details{
This function flushes any modified data (in \acronym{RAM}) of a file-backed
\code{big.matrix} to disk.  This may be useful for
improving performance in cases where allowing the operating system to decide
on flushing creates a bottleneck (likely near the threshold of available \acronym{RAM}).
}
\examples{
temp_dir = tempdir()
if (!dir.exists(temp_dir)) dir.create(temp_dir)
x <- big.matrix(nrow=3, ncol=3, backingfile='flushtest.bin',
                descriptorfile='flushtest.desc', backingpath=temp_dir,
                type='integer')
x[1,1] <- 0
flush(x)
}
\author{
John W. Emerson and Michael J. Kane
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\docType{methods}
\name{Extract,big.matrix}
\alias{Extract,big.matrix}
\alias{[,big.matrix,ANY,ANY,missing-method}
\alias{[<-,big.matrix,ANY,ANY,ANY-method}
\alias{[,big.matrix,ANY,ANY,logical-method}
\alias{[,big.matrix,missing,ANY,missing-method}
\alias{[,big.matrix,missing,ANY,logical-method}
\alias{[,big.matrix,ANY,missing,missing-method}
\alias{[,big.matrix,ANY,missing,logical-method}
\alias{[,big.matrix,missing,missing,missing-method}
\alias{[,big.matrix,missing,missing,logical-method}
\alias{[,big.matrix,matrix,missing,missing-method}
\alias{[<-,big.matrix,numeric,numeric,ANY-method}
\alias{[<-,big.matrix,numeric,logical,ANY-method}
\alias{[<-,big.matrix,logical,numeric,ANY-method}
\alias{[<-,big.matrix,logical,logical,ANY-method}
\alias{[<-,big.matrix,logical,character,ANY-method}
\alias{[<-,big.matrix,numeric,character,ANY-method}
\alias{[<-,big.matrix,missing,missing,ANY-method}
\alias{[<-,big.matrix,missing,numeric,ANY-method}
\alias{[<-,big.matrix,missing,logical,ANY-method}
\alias{[<-,big.matrix,numeric,missing,numeric-method}
\alias{[<-,big.matrix,logical,missing,numeric-method}
\alias{[<-,big.matrix,numeric,missing,matrix-method}
\alias{[<-,big.matrix,logical,missing,matrix-method}
\alias{[<-,big.matrix,character,character,ANY-method}
\alias{[<-,big.matrix,missing,character,ANY-method}
\alias{[<-,big.matrix,character,missing,ANY-method}
\alias{[<-,big.matrix,missing,missing,numeric-method}
\alias{[<-,big.matrix,matrix,missing,numeric-method}
\title{Extract or Replace}
\usage{
\S4method{[}{big.matrix,ANY,ANY,missing}(x, i, j, drop)

\S4method{[}{big.matrix,ANY,ANY,logical}(x, i, j, drop)

\S4method{[}{big.matrix,missing,ANY,missing}(x, i, j, drop)

\S4method{[}{big.matrix,missing,ANY,logical}(x, i, j, drop)

\S4method{[}{big.matrix,ANY,missing,missing}(x, i, j, ..., drop = TRUE)

\S4method{[}{big.matrix,ANY,missing,logical}(x, i, j, drop)

\S4method{[}{big.matrix,missing,missing,missing}(x, i, j, drop)

\S4method{[}{big.matrix,missing,missing,logical}(x, i, j, drop)

\S4method{[}{big.matrix,matrix,missing,missing}(x, i, j, drop)

\S4method{[}{big.matrix,numeric,numeric,ANY}(x, i, j) <- value

\S4method{[}{big.matrix,numeric,logical,ANY}(x, i, j) <- value

\S4method{[}{big.matrix,logical,numeric,ANY}(x, i, j) <- value

\S4method{[}{big.matrix,logical,logical,ANY}(x, i, j) <- value

\S4method{[}{big.matrix,logical,character,ANY}(x, i, j) <- value

\S4method{[}{big.matrix,numeric,character,ANY}(x, i, j) <- value

\S4method{[}{big.matrix,missing,missing,ANY}(x, i, j) <- value

\S4method{[}{big.matrix,missing,numeric,ANY}(x, i, j) <- value

\S4method{[}{big.matrix,missing,logical,ANY}(x, i, j) <- value

\S4method{[}{big.matrix,numeric,missing,numeric}(x, i, j, ...) <- value

\S4method{[}{big.matrix,logical,missing,numeric}(x, i, j, ...) <- value

\S4method{[}{big.matrix,numeric,missing,matrix}(x, i, j, ...) <- value

\S4method{[}{big.matrix,logical,missing,matrix}(x, i, j, ...) <- value

\S4method{[}{big.matrix,character,character,ANY}(x, i, j) <- value

\S4method{[}{big.matrix,missing,character,ANY}(x, j) <- value

\S4method{[}{big.matrix,character,missing,ANY}(x, i) <- value

\S4method{[}{big.matrix,missing,missing,numeric}(x, i, j) <- value

\S4method{[}{big.matrix,matrix,missing,numeric}(x, i, j) <- value
}
\arguments{
\item{x}{A \code{big.matrix object}}

\item{i}{Indices specifying the rows}

\item{j}{Indices specifying the columns}

\item{drop}{Logical indication if reduce to minimum dimensions}

\item{...}{Additional arguments}

\item{value}{typically an array-like R object of similar class}
}
\description{
Extract or replace big.matrix elements
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\name{deepcopy}
\alias{deepcopy}
\title{Produces a physical copy of a ``big.matrix''}
\usage{
deepcopy(
  x,
  cols = NULL,
  rows = NULL,
  y = NULL,
  type = NULL,
  separated = NULL,
  backingfile = NULL,
  backingpath = NULL,
  descriptorfile = NULL,
  binarydescriptor = FALSE,
  shared = options()$bigmemory.default.shared
)
}
\arguments{
\item{x}{a \code{\link{big.matrix}}.}

\item{cols}{possible subset of columns for the deepcopy; could be numeric,
named, or logical.}

\item{rows}{possible subset of rows for the deepcopy; could be numeric,
named, or logical.}

\item{y}{optional destination object (\code{matrix} or \code{big.matrix});
if not specified, a \code{big.matrix} will be created.}

\item{type}{preferably specified, \code{"integer"} for example.}

\item{separated}{use separated column organization of the data instead of
column-major organization; use with caution if the number of columns is
large.}

\item{backingfile}{the root name for the file(s) for the cache of \code{x}.}

\item{backingpath}{the path to the directory containing the file-backing
cache.}

\item{descriptorfile}{we recommend specifying this for file-backing.}

\item{binarydescriptor}{the flag to specify if the binary RDS format should
be used for the backingfile description, for subsequent use with
\code{\link{attach.big.matrix}}; if \code{NULL} of \code{FALSE}, the
\code{dput()} file format is used.}

\item{shared}{\code{TRUE} by default, and always \code{TRUE} if the
\code{big.matrix} is file-backed.  For a non-filebacked \code{big.matrix},
\code{shared=FALSE} uses non-shared memory, which can be more stable for
large (say, >50\\% of RAM) objects.  Shared memory allocation can sometimes
fail in such cases due to exhausted shared-memory resources in the system.}
}
\value{
a \code{\link{big.matrix}}.
}
\description{
This is needed to make a duplicate of a \code{big.matrix}, with the new copy
optionally filebacked.
}
\details{
This is needed to make a duplicate of a \code{\link{big.matrix}}, because
traditional syntax would only copy the object (the pointer to the
\code{\link{big.matrix}} rather than the \code{\link{big.matrix}} itself).
It can also make a copy of only a subset of columns.
}
\examples{
x <- as.big.matrix(matrix(1:30, 10, 3))
y <- deepcopy(x, -1)    # Don't include the first column.
x
y
head(x)
head(y)
}
\seealso{
\code{\link{big.matrix}}
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\docType{class}
\name{big.matrix.descriptor-class}
\alias{big.matrix.descriptor-class}
\alias{attach.resource,character-method}
\alias{attach.resource,big.matrix.descriptor-method}
\title{Class "big.matrix.descriptor"}
\usage{
\S4method{attach.resource}{character}(obj, ...)

\S4method{attach.resource}{big.matrix.descriptor}(obj, ...)
}
\arguments{
\item{obj}{The filename of the descriptor for a filebacked matrix,
assumed to be in the directory specified}

\item{...}{possibly \code{path} which gives the path where the descriptor
and/or filebacking can be found.}
}
\description{
An object of this class contains necessary and sufficient information
to ``attach'' a shared or filebacked \code{\link{big.matrix}}.
}
\note{
We provide \code{attach.resource} for convenience, but expect most users
will prefer \code{\link{attach.big.matrix}}.
}
\section{Objects from the Class}{

Objects should not be created by calls of the form \code{new("big.matrix.descriptor", ...)},
but should use the \code{\link{describe}} function.
}

\section{Slots}{

\describe{
\item{\code{description}:}{Object of class \code{"list"}; details omitted.}
}
}

\section{Extends}{

Class \code{"descriptor"}, directly.
}

\section{Methods}{

\describe{
\item{attach.resource}{\code{signature(obj = "big.matrix.descriptor")}: ... }
\item{sub.big.matrix}{\code{signature(x = "big.matrix.descriptor")}: ... }
}
}

\examples{
showClass("big.matrix.descriptor")
}
\references{
Other types of descriptors are defined in package \pkg{synchronicity}.
}
\seealso{
See also \code{\link{attach.big.matrix}}.
}
\author{
John W. Emerson and Michael J. Kane
}
\keyword{classes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\name{is.float}
\alias{is.float}
\title{Check if Float}
\usage{
is.float(x)
}
\arguments{
\item{x}{An object to be evaluated if float}
}
\description{
Check to see if the elements of a big.matrix object are floats.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\name{big.matrix}
\alias{big.matrix}
\alias{filebacked.big.matrix}
\alias{as.big.matrix}
\alias{is.big.matrix}
\alias{is.big.matrix,big.matrix-method}
\alias{is.big.matrix,ANY-method}
\alias{is.separated}
\alias{is.separated,big.matrix-method}
\alias{is.filebacked}
\alias{is.filebacked,big.matrix-method}
\alias{shared.name}
\alias{shared.name,big.matrix-method}
\alias{file.name}
\alias{file.name,big.matrix-method}
\alias{dir.name}
\alias{dir.name,big.matrix-method}
\alias{is.shared}
\alias{is.shared,big.matrix-method}
\alias{is.readonly}
\alias{is.readonly,big.matrix-method}
\alias{is.nil}
\title{The core "big.matrix" operations.}
\usage{
big.matrix(
  nrow,
  ncol,
  type = options()$bigmemory.default.type,
  init = NULL,
  dimnames = NULL,
  separated = FALSE,
  backingfile = NULL,
  backingpath = NULL,
  descriptorfile = NULL,
  binarydescriptor = FALSE,
  shared = options()$bigmemory.default.shared
)

filebacked.big.matrix(
  nrow,
  ncol,
  type = options()$bigmemory.default.type,
  init = NULL,
  dimnames = NULL,
  separated = FALSE,
  backingfile = NULL,
  backingpath = NULL,
  descriptorfile = NULL,
  binarydescriptor = FALSE
)

as.big.matrix(
  x,
  type = NULL,
  separated = FALSE,
  backingfile = NULL,
  backingpath = NULL,
  descriptorfile = NULL,
  binarydescriptor = FALSE,
  shared = options()$bigmemory.default.shared
)

is.big.matrix(x)

\S4method{is.big.matrix}{big.matrix}(x)

\S4method{is.big.matrix}{ANY}(x)

is.separated(x)

\S4method{is.separated}{big.matrix}(x)

is.filebacked(x)

\S4method{is.filebacked}{big.matrix}(x)

shared.name(x)

\S4method{shared.name}{big.matrix}(x)

file.name(x)

\S4method{file.name}{big.matrix}(x)

dir.name(x)

\S4method{dir.name}{big.matrix}(x)

is.shared(x)

\S4method{is.shared}{big.matrix}(x)

is.readonly(x)

\S4method{is.readonly}{big.matrix}(x)

is.nil(address)
}
\arguments{
\item{nrow}{number of rows.}

\item{ncol}{number of columns.}

\item{type}{the type of the atomic element
(\code{options()$bigmemory.default.type} by default -- \code{"double"} --
but can be changed by the user to \code{"integer"}, \code{"short"}, or
\code{"char"}).}

\item{init}{a scalar value for initializing the matrix (\code{NULL} by
default to avoid unnecessary time spent doing the initializing).}

\item{dimnames}{a list of the row and column names; use with caution
for large objects.}

\item{separated}{use separated column organization of the data;
see details.}

\item{backingfile}{the root name for the file(s) for the cache of \code{x}.}

\item{backingpath}{the path to the directory containing the file
backing cache.}

\item{descriptorfile}{the name of the file to hold the backingfile
description, for subsequent use with \code{\link{attach.big.matrix}};
if \code{NULL}, the \code{backingfile} is used as the root part of the
descriptor file name.  The descriptor file is placed in the same directory
as the backing files.}

\item{binarydescriptor}{the flag to specify if the binary RDS format
should be used for the backingfile description, for subsequent use with
\code{\link{attach.big.matrix}}; if \code{NULL} of \code{FALSE}, the
\code{dput()} file format is used.}

\item{shared}{\code{TRUE} by default, and always \code{TRUE} if the
\code{big.matrix} is file-backed.  For a non-filebacked \code{big.matrix},
\code{shared=FALSE} uses non-shared memory, which can be more stable for
large (say, >50\% of RAM) objects.  Shared memory allocation can sometimes
fail in such cases due to exhausted shared-memory resources in the system.}

\item{x}{a \code{matrix}, \code{vector}, or \code{data.frame} for
\code{as.big.matrix}; if a vector, a one-column\cr \code{big.matrix} is
created by \code{as.big.matrix}; if a \code{data.frame}, see details.
For the \code{is.*} functions, \code{x} is likely a \code{big.matrix}.}

\item{address}{an \code{externalptr}, so \code{is.nil(x@address)} might
be a sensible thing to want to check, but it's pretty obscure.}
}
\value{
A \code{big.matrix} is returned (for \code{big.matrix} and
\code{filebacked.big.matrix}, and\cr \code{as.big.matrix}),
and \code{TRUE} or \code{FALSE} for \code{is.big.matrix} and the
other functions.
}
\description{
Create a \code{big.matrix} (or check to see if an object
is a \code{big.matrix}, or create a \code{big.matrix} from a
\code{\link{matrix}}, and so on).  The \code{big.matrix} may be file-backed.
}
\details{
A \code{big.matrix} consists of an object in \R that does nothing
more than point to the data structure implemented in \acronym{C++}.  The
object acts much like a traditional \R matrix, but helps protect the user
from many inadvertent memory-consuming pitfalls of traditional \R matrices
and data frames.

There are two \code{big.matrix} types which manage
data in different ways.  A standard, shared \code{big.matrix} is constrained
to available \acronym{RAM}, and may be shared across separate \R processes.
A file-backed \code{big.matrix} may exceed available \acronym{RAM} by
using hard drive space, and may also be shared across processes.  The
atomic types of these matrices may be \code{double}, \code{integer},
\code{short}, or \code{char} (8, 4, 2, and 1 bytes, respectively).

If \code{x} is a \code{big.matrix}, then \code{x[1:5,]} is returned as an R
\code{matrix} containing the first five rows of \code{x}.  If \code{x} is of
type \code{double}, then the result will be \code{numeric}; otherwise, the
result will be an \code{integer} \R matrix.  The expression \code{x} alone
will display information about the \R object (e.g. the external pointer)
rather than evaluating the matrix itself (the user should try \code{x[,]}
with extreme caution, recognizing that a huge \R \code{matrix} will
be created).

If \code{x} has a huge number of rows and/or columns, then the use of
\code{rownames} and/or \code{colnames} will be extremely memory-intensive
and should be avoided.  If \code{x} has a huge number of columns and
\code{separated=TRUE} is used (this isn't typically recommended),
the user might want to store the transpose as there is overhead of a
pointer for each column in the matrix. If \code{separated} is \code{TRUE},
then the memory is allocated into separate vectors for each column.
Use this option with caution if you have a large number of columns, as
shared-memory segments are limited by OS and hardware combinations. If
\code{separated} is \code{FALSE}, the matrix is stored in traditional
column-major format. The function \code{is.separated()} returns the
separation type of the \code{big.matrix}.

When a \code{big.matrix}, \code{x}, is passed as an argument
to a function, it is essentially providing call-by-reference rather than
call-by-value behavior.  If the function modifies any of the values of
\code{x}, the changes are not limited in scope to a local copy within the
function. This introduces the possibility of side-effects, in contrast to
standard \R behavior.

A file-backed \code{big.matrix} may exceed available \acronym{RAM} in size
by using a file cache (or possibly multiple file caches, if
\code{separated=TRUE}). This can incur a substantial performance penalty for
such large matrices, but less of a penalty than most other approaches for
handling such large objects. A side-effect of creating a file-backed object
is not only the file-backing(s), but a descriptor file (in the same
directory) that is needed for subsequent attachments (see
\code{\link{attach.big.matrix}}).

Note that we do not allow setting or changing the \code{dimnames} attributes
by default; such changes would not be reflected in the descriptor objects or
in shared memory.  To override this, set
\code{options(bigmemory.allow.dimnames=TRUE)}.

It should also be noted that a user can create an ``anonymous'' file-backed
\code{big.matrix} by specifying "" as the \code{filebacking} argument.
In this case, the backing resides in the temporary directory and a
descriptor file is not created.  These should be used with caution since
even anonymous backings use disk space which could eventually fill the
hard drive.  Anonymous backings are removed either manually, by a
user, or automatically, when the operating system deems it appropriate.

Finally, note that \code{as.big.matrix} can coerce data frames.  It does
this by making any character columns into factors, and then making all
factors numeric before forming the \code{big.matrix}.  Level labels are
not preserved and must be managed by the user if desired.
}
\examples{
library(bigmemory)
x <- big.matrix(10, 2, type='integer', init=-5)
options(bigmemory.allow.dimnames=TRUE)
colnames(x) <- c("alpha", "beta")
is.big.matrix(x)
dim(x)
colnames(x)
rownames(x)
x[,]
x[1:8,1] <- 11:18
colnames(x) <- NULL
x[,]

# The following shared memory example is quite silly, as you wouldn't
# likely do this in a single R session.  But if zdescription were
# passed to another R session via SNOW, foreach, or even by a
# simple file read/write, then the attach.big.matrix() within the
# second R process would give access to the same object in memory.
# Please see the package vignette for real examples.

z <- big.matrix(3, 3, type='integer', init=3)
z[,]
dim(z)
z[1,1] <- 2
z[,]
zdescription <- describe(z)
zdescription
y <- attach.big.matrix(zdescription)
y[,]
y
z
y[1,1] <- -100
y[,]
z[,]
}
\references{
The Bigmemory Project: \url{http://www.bigmemory.org/}.
}
\seealso{
\code{\link{bigmemory}}, and perhaps the class documentation of
\code{\linkS4class{big.matrix}}; \code{\link{attach.big.matrix}} and
\code{\link{describe}}.  Sister packages \pkg{biganalytics}, \pkg{bigtabulate},
\pkg{synchronicity}, and \pkg{bigalgebra} provide advanced functionality.
}
\author{
John W. Emerson and Michael J. Kane
\email{<bigmemoryauthors@gmail.com>}
}
\keyword{classes}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\docType{class}
\name{big.matrix-class}
\alias{big.matrix-class}
\title{Class "big.matrix"}
\description{
The \code{big.matrix} class is designed for matrices with
elements of type \code{double}, \code{integer}, \code{short}, or \code{char}.
A \code{big.matrix} acts much like a traditional \R matrix, but helps protect
the user from many inadvertent memory-consuming pitfalls of traditional \R
matrices and data frames.  The objects are allocated to shared memory,
and if file-backing is used they may exceed virtual memory in size.  Sadly,
32-bit operating system constraints -- largely Windows and some MacOS versions
--will be a limiting factor with file-backed matrices; 64-bit operating
systems are recommended.
}
\section{Objects from the Class}{

Unlike many \R objects, objects should not be created by calls of the form
\code{new("big.matrix", ...)}.  The functions \code{big.matrix()}
and \code{filebacked.big.matrix()} are intended for the user.
}

\section{Slots}{

\describe{\item{\code{address}:}{Object of class \code{"externalptr"}
points to the memory location of the \acronym{C++} data structure.}}
}

\section{Methods}{

\describe{
As you would expect:
\item{[<-}{\code{signature(x = "big.matrix", i = "ANY", j = "ANY")}: ... }
\item{[<-}{\code{signature(x = "big.matrix", i = "ANY", j = "missing")}: ... }
\item{[<-}{\code{signature(x = "big.matrix", i = "missing", j = "ANY")}: ... }
\item{[<-}{\code{signature(x = "big.matrix", i = "missing", j = "missing")}: ... }
\item{[<-}{\code{signature(x = "big.matrix", i = "matrix", j = "missing")}: ... }
\item{[}{\code{signature(x = "big.matrix", i = "ANY", j = "ANY", drop = "missing")}: ... }
\item{[}{\code{signature(x = "big.matrix", i = "ANY", j = "ANY", drop = "logical")}: ... }
\item{[}{\code{signature(x = "big.matrix", i = "ANY", j = "missing", drop = "missing")}: ... }
\item{[}{\code{signature(x = "big.matrix", i = "ANY", j = "missing", drop = "logical")}: ... }
\item{[}{\code{signature(x = "big.matrix", i = "matrix", j = "missing", drop = "logical")}: ... }
\item{[}{\code{signature(x = "big.matrix", i = "missing", j = "ANY", drop = "missing")}: ... }
\item{[}{\code{signature(x = "big.matrix", i = "missing", j = "ANY", drop = "logical")}: ... }
\item{[}{\code{signature(x = "big.matrix", i = "missing", j = "missing", drop = "missing")}: ... }
\item{[}{\code{signature(x = "big.matrix", i = "missing", j = "missing", drop = "logical")}: ... }

The following are probably more interesting:
\item{describe}{\code{signature(x = "big.matrix")}: provide necessary and
sufficient information for the sharing or re-attaching of the object. }
\item{dim}{\code{signature(x = "big.matrix")}: returns the dimension of the
\code{big.matrix}. }
\item{length}{\code{signature(x = "big.matrix")}: returns the product of the
dimensions of the \code{big.matrix}. }
\item{dimnames<-}{\code{signature(x = "big.matrix", value = "list")}: set
the row and column names, prohibited by default (see \code{\link{bigmemory}}
to override). }
\item{dimnames}{\code{signature(x = "big.matrix")}: get the row and column
names. }
\item{head}{\code{signature(x = "big.matrix")}: get the first 6 (or
\code{n}) rows. }
\item{as.matrix}{\code{signature(x = "big.matrix")}: coerce a
\code{big.matrix} to a \code{matrix}. }
\item{is.big.matrix}{\code{signature(x = "big.matrix")}: return \code{TRUE}
if it's a \code{big.matrix}. }
\item{is.filebacked}{\code{signature(x = "big.matrix")}: return \code{TRUE}
if there is a file-backing. }
\item{is.separated}{\code{signature(x = "big.matrix") }: return \code{TRUE}
if the \code{big.matrix} is organized as a separated column vectors.}
\item{is.sub.big.matrix}{\code{signature(x = "big.matrix")}: return
\code{TRUE} if this is a sub-matrix of a \code{big.matrix}. }
\item{ncol}{\code{signature(x = "big.matrix")}: returns the number of
columns.  }
\item{nrow}{\code{signature(x = "big.matrix")}: returns the number of rows. }
\item{print}{\code{signature(x = "big.matrix")}: a traditional \code{print()}
is intentionally disabled, and returns \code{head(x)} unless
\code{options()$bm.print.warning==FALSE}; in this case, \code{print(x[,])}
is the result, which could be very big! }

\item{sub.big.matrix}{\code{signature(x = "big.matrix")}: for
contiguous submatrices. }
\item{tail}{\code{signature(x = "big.matrix")}: returns the last 6 (or
\code{n}) rows. }
\item{typeof}{\code{signature(x = "big.matrix")}: return the type of the
atomic elements of the \code{big.matrix}.}
\item{write.big.matrix}{\code{signature(bigMat = "big.matrix", 
fileName = "character")}: produce an ASCII file from the \code{big.matrix}.}
\item{apply}{\code{signature(x = "big.matrix")}: \code{apply()} where
\code{MARGIN} may only be 1 or 2, but otherwise conforming to what you
would expect from \code{apply()}.}
}
}

\examples{
showClass("big.matrix")
}
\seealso{
\code{\link{big.matrix}}
}
\author{
Michael J. Kane and John W. Emerson
\email{bigmemoryauthors@gmail.com}
}
\keyword{classes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\name{describe,big.matrix-method}
\alias{describe,big.matrix-method}
\alias{attach.big.matrix}
\alias{describe}
\alias{attach.resource}
\title{The basic ``big.matrix'' operations for sharing and re-attaching.}
\usage{
\S4method{describe}{big.matrix}(x)

attach.big.matrix(obj, ...)
}
\arguments{
\item{x}{a \code{\link{big.matrix}} object}

\item{obj}{an object as returned by \code{describe()} or, optionally,
the filename of the descriptor for a filebacked matrix, assumed to be in
the directory specified by the \code{path} (if one is provided)}

\item{...}{possibly \code{path} which gives the path where the descriptor
and/or filebacking can be found}
}
\value{
\code{describe} returns a list of of the information needed to attach to
a \code{big.matrix} object.

\code{attach.big.matrix} return a new instance of type \code{big.matrix}
corresponding to a shared-memory or file-backed \code{big.matrix}.
}
\description{
The \code{describe} function returns the information needed by
\code{attach.big.matrix} to reference a shared or file-backed
\code{big.matrix} object.
The \code{attach.big.matrix} and \code{attach.resource} functions create a
new \code{big.matrix} object based on the descriptor information referencing
previously allocated shared-memory or file-backed matrices.
}
\details{
The \code{describe} function returns a list of the information needed to
attach to a \code{big.matrix} object.
A descriptor file is automatically created when a new filebacked
\code{big.matrix} is created.
}
\examples{
# The example is quite silly, as you wouldn't likely do this in a
# single R session.  But if zdescription were passed to another R session
# via SNOW, foreach, or even by a simple file read/write,
# then the attach of the second R process would give access to the
# same object in memory.  Please see the package vignette for real examples.

z <- big.matrix(3, 3, type='integer', init=3)
z[,]
dim(z)
z[1,1] <- 2
z[,]
zdescription <- describe(z)
zdescription
y <- attach.big.matrix(zdescription)
y[,]
y
z
zz <- attach.resource(zdescription)
zz[1,1] <- -100
y[,]
z[,]
}
\seealso{
\code{\link{bigmemory}}, \code{\link{big.matrix}}, or the class
documentation \code{\linkS4class{big.matrix}}.
}
\author{
Michael J. Kane and John W. Emerson
\email{bigmemoryauthors@gmail.com}
}
\keyword{classes}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\name{print,big.matrix-method}
\alias{print,big.matrix-method}
\title{Print Values}
\usage{
\S4method{print}{big.matrix}(x)
}
\arguments{
\item{x}{A \code{big.matrix} object}
}
\description{
\code{print} will print out the elements within
a \code{big.matrix} object.
}
\note{
By default, this will only return the \code{head} of a big.matrix
to prevent console overflow.  If you turn off the bigmemory.print.warning
option then it will convert to a base R matrix and print all elements.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\docType{methods}
\name{head,big.matrix-method}
\alias{head,big.matrix-method}
\alias{tail,big.matrix-method}
\title{Return First or Last Part of a big.matrix Object}
\usage{
\S4method{head}{big.matrix}(x, n = 6)

\S4method{tail}{big.matrix}(x, n = 6)
}
\arguments{
\item{x}{A big.matrix object}

\item{n}{A single integer for the number of rows to return}
}
\description{
Returns the first or last parts of a \code{big.matrix}
object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\docType{methods}
\name{mwhich-methods}
\alias{mwhich-methods}
\alias{mwhich,big.matrix,ANY,ANY,ANY,character-method}
\alias{mwhich,big.matrix,ANY,ANY,ANY,missing-method}
\alias{mwhich,matrix,ANY,ANY,ANY,character-method}
\alias{mwhich,matrix,ANY,ANY,ANY,missing-method}
\title{Expanded ``which''-like functionality.}
\description{
Implements \code{\link{which}}-like functionality for a
\code{\link{big.matrix}}, with additional options for efficient comparisons
(executed in \acronym{C++}); also works for regular numeric matrices without
the memory overhead.
test
}
\section{Methods}{

\describe{
\item{signature(x = "big.matrix=", cols
= "ANY", vals = "ANY",", " comps = "ANY", op = "character")}{
... }
\item{signature(x = "big.matrix", cols = "ANY", vals =
"ANY",", " comps = "ANY", op = "missing")}{ ... }
\item{signature(x = "matrix", cols = "ANY", vals = "ANY",", "
comps = "ANY", op = "character")}{ ... }
\item{signature(x = "matrix", cols = "ANY", vals = "ANY",",
" comps = "ANY", op = "missing")}{ ... } }
}

\seealso{
\code{\link{big.matrix}}, \code{\link{which}}, \code{\link{mwhich}}
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\docType{methods}
\name{dimnames,big.matrix-method}
\alias{dimnames,big.matrix-method}
\alias{dimnames<-,big.matrix,list-method}
\title{Dimnames of a big.matrix Object}
\usage{
\S4method{dimnames}{big.matrix}(x)

\S4method{dimnames}{big.matrix,list}(x) <- value
}
\arguments{
\item{x}{A big.matrix object}

\item{value}{A possible value for \code{dimnames(x)}}
}
\description{
Retrieve or set the dimnames of an object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\name{as.matrix,big.matrix-method}
\alias{as.matrix,big.matrix-method}
\title{Convert to base R matrix}
\usage{
\S4method{as.matrix}{big.matrix}(x)
}
\arguments{
\item{x}{A big.matrix object}
}
\description{
Extract values from a \code{big.matrix} object
and convert to a base R matrix object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\name{is.sub.big.matrix}
\alias{is.sub.big.matrix}
\alias{is.sub.big.matrix,big.matrix-method}
\alias{sub.big.matrix}
\alias{sub.big.matrix,big.matrix-method}
\title{Submatrix support}
\usage{
is.sub.big.matrix(x)

\S4method{is.sub.big.matrix}{big.matrix}(x)

sub.big.matrix(
  x,
  firstRow = 1,
  lastRow = NULL,
  firstCol = 1,
  lastCol = NULL,
  backingpath = NULL
)

\S4method{sub.big.matrix}{big.matrix}(
  x,
  firstRow = 1,
  lastRow = NULL,
  firstCol = 1,
  lastCol = NULL,
  backingpath = NULL
)
}
\arguments{
\item{x}{either a \code{\link{big.matrix}} or a descriptor.}

\item{firstRow}{the first row of the submatrix.}

\item{lastRow}{the last row of the submatrix if not \code{NULL}.}

\item{firstCol}{the first column of the submatrix.}

\item{lastCol}{the last column of the submatrix if not \code{NULL}.}

\item{backingpath}{required path to the filebacked object, if applicable.}
}
\value{
A \code{\link{big.matrix}} which is actually a submatrix of a larger \code{big.matrix}.
It is not a physical copy.  Only contiguous blocks may form a submatrix.
}
\description{
This doesn't create a copy, it just provides a new version of the class
which provides behavior for a contiguous submatrix of the big.matrix.
Non-contiguous submatrices are not supported.
}
\details{
The \code{sub.big.matrix} function allows a user to create a \code{big.matrix}
object that references a contiguous set of columns and rows of another
\code{big.matrix} object.

The \code{is.sub.big.matrix} function returns \code{TRUE} if the specified
argument is a \code{sub.big.matrix} object and return \code{FALSE}
otherwise.
}
\examples{
x <- big.matrix(10, 5, init=0, type="double")
x[,] <- 1:50
y <- sub.big.matrix(x, 2, 9, 2, 3)
y[,]
y[1,1] <- -99
x[,]
rm(x)
}
\seealso{
\code{\link{big.matrix}}
}
\author{
John W. Emerson and Michael J. Kane
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\name{dim,big.matrix-method}
\alias{dim,big.matrix-method}
\title{Dimensions of a big.matrix object}
\usage{
\S4method{dim}{big.matrix}(x)
}
\arguments{
\item{x}{A \code{big.matrix} object}
}
\description{
Retrieve the dimensions of a \code{big.matrix} object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\name{morder}
\alias{morder}
\alias{morderCols}
\alias{mpermute}
\alias{mpermuteCols}
\title{Ordering and Permuting functions for \verb{big.matrix'' and  }matrix'' objects}
\usage{
morder(x, cols, na.last = TRUE, decreasing = FALSE)

morderCols(x, rows, na.last = TRUE, decreasing = FALSE)

mpermute(x, order = NULL, cols = NULL, allow.duplicates = FALSE, ...)

mpermuteCols(x, order = NULL, rows = NULL, allow.duplicates = FALSE, ...)
}
\arguments{
\item{x}{A \code{big.matrix} or \code{matrix} object with numeric values.}

\item{cols}{The columns of \code{x} to get the ordering for or reorder on}

\item{na.last}{for controlling the treatment of \code{NA}s. If
\code{TRUE}, missing values in the data are put last; if \code{FALSE},
they are put first; if \code{NA}, they are removed.}

\item{decreasing}{logical. Should the sort order be increasing or
decreasing?}

\item{rows}{The rows of \code{x} to get the ordering for or reorder on}

\item{order}{A vector specifying the reordering of rows, i.e. the
result of a call to \code{order} or \code{morder}.}

\item{allow.duplicates}{ff \code{TRUE}, allows a row to be duplicated in
the resulting \code{big.matrix} or \code{matrix} (i.e. in this case,
\code{order} would not need to be a permutation of \code{1:nrow(x)}).}

\item{...}{optional parameters to pass to \code{morder} when \code{cols}
is specified instead of just using \code{order}.}
}
\value{
\code{morder} returns an ordering vector.
\code{mpermute} returns nothing but does change the contents of \code{x}.
This type of a side-effect is generally frowned upon in \R, but we ``break''
the rules here to avoid memory overhead and improve performance.
}
\description{
The \code{morder} function returns a permutation of row
indices which can be used to rearrange an object according to the values
in the specified columns (a multi-column ordering).
The \code{mpermute} function actually reorders the rows of a
\code{big.matrix} or \code{matrix} based on
an order vector or a desired ordering on a set of columns.
}
\details{
The \code{morder} function behaves similar to \code{order},
returning a permutation of \code{1:nrow(x)} which rearranges objects
according to the values in the specified columns. However, \code{morder}
takes a \code{big.matrix} or an \R \code{matrix} (with numeric type) and
a set of columns (\code{cols}) with which to determine the ordering;
\code{morder} does not incur the same memory overhead required by
\code{order}, and runs more quickly.

The \code{mpermute} function changes the row ordering of a \code{big.matrix}
or \code{matrix} based on a vector \code{order} or an ordering based
on a set of columns specified by \code{cols}.  It should be noted that
this function has side-effects, that is \code{x} is changed when this
function is called.
}
\examples{
m = matrix(as.double(as.matrix(iris)), nrow=nrow(iris))
morder(m, 1)
order(m[,1])

m[order(m[,1]), 2]
mpermute(m, cols=1)
m[,2]
}
\seealso{
\code{\link{order}}
}
\author{
Michael J. Kane \email{<bigmemoryauthors@gmail.com>}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bigmemory.R
\name{mwhich}
\alias{mwhich}
\title{Expanded ``which''-like functionality.}
\usage{
mwhich(x, cols, vals, comps, op = "AND")
}
\arguments{
\item{x}{a \code{\link{big.matrix}} (or a numeric matrix; see below).}

\item{cols}{a vector of column indices or names.}

\item{vals}{a list (one component for each of \code{cols}) of vectors of
length 1 or 2; length 1 is used to test equality (or inequality), while
vectors of length 2 are used for checking values in the range (\code{-Inf}
and \code{Inf} are allowed). If a scalar or vector of length 2 is provided
instead of a list, it will be replicated \code{length(cols)} times.}

\item{comps}{a list of operators (one component for each of \code{cols}),
including \code{'eq'}, \code{'neq'}, \code{'le'}, \code{'lt'}, \code{'ge'}
and \code{'gt'}.  If a single operator, it will be replicated
\code{length(cols)} times.}

\item{op}{the comparison operator for combining the results of the
individual tests, either \code{'AND'} or \code{'OR'}.}
}
\value{
a vector of row indices satisfying the criteria.
}
\description{
Implements \code{\link{which}}-like functionality for a \code{\link{big.matrix}},
with additional options for efficient comparisons (executed in \acronym{C++});
also works for regular numeric matrices without the memory overhead.
}
\details{
To improve performance and avoid the creation of massive temporary vectors
in \R when doing comparisons, \code{mwhich()} efficiently executes
column-by-column comparisons of values to the specified values or ranges,
and then returns the row indices satisfying the comparison specified by the
\code{op} operator.  More advanced comparisons are then possible
(and memory-efficient) in \R by doing set operations (\code{\link{union}}
and \code{\link{intersect}}, for example) on the results of multiple
\code{mwhich()} calls.

Note that \code{NA} is a valid argument in conjunction with \code{'eq'} or
\code{'neq'}, replacing traditional \code{is.na()} calls.
And both \code{-Inf} and \code{Inf} can be used for one-sided inequalities.

If \code{mwhich()} is used with a regular numeric \R \code{matrix}, we
access the data directly and thus incur no memory overhead.  Interested
developers might want to look at our code for this case, which uses a handy
pointer trick (accessor) in \acronym{C++}.
}
\examples{
x <- as.big.matrix(matrix(1:30, 10, 3))
options(bigmemory.allow.dimnames=TRUE)
colnames(x) <- c("A", "B", "C")
x[,]
x[mwhich(x, 1:2, list(c(2,3), c(11,17)),
         list(c('ge','le'), c('gt', 'lt')), 'OR'),]

x[mwhich(x, c("A","B"), list(c(2,3), c(11,17)), 
         list(c('ge','le'), c('gt', 'lt')), 'AND'),]

# These should produce the same answer with a regular matrix:
y <- matrix(1:30, 10, 3)
y[mwhich(y, 1:2, list(c(2,3), c(11,17)),
         list(c('ge','le'), c('gt', 'lt')), 'OR'),]

y[mwhich(y, -3, list(c(2,3), c(11,17)),
         list(c('ge','le'), c('gt', 'lt')), 'AND'),]


x[1,1] <- NA
mwhich(x, 1:2, NA, 'eq', 'OR')
mwhich(x, 1:2, NA, 'neq', 'AND')

# Column 1 equal to 4 and/or column 2 less than or equal to 16:
mwhich(x, 1:2, list(4, 16), list('eq', 'le'), 'OR')
mwhich(x, 1:2, list(4, 16), list('eq', 'le'), 'AND')

# Column 2 less than or equal to 15:
mwhich(x, 2, 15, 'le')

# No NAs in either column, and column 2 strictly less than 15:
mwhich(x, c(1:2,2), list(NA, NA, 15), list('neq', 'neq', 'lt'), 'AND')

x <- big.matrix(4, 2, init=1, type="double")
x[1,1] <- Inf
mwhich(x, 1, Inf, 'eq')
mwhich(x, 1, 1, 'gt')
mwhich(x, 1, 1, 'le')
}
\seealso{
\code{\link{big.matrix}}, \code{\link{which}}
}
\author{
John W. Emerson \email{<bigmemoryauthors@gmail.com>}
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{GetMatrixSize}
\alias{GetMatrixSize}
\title{big.matrix size}
\usage{
GetMatrixSize(bigMat)
}
\arguments{
\item{bigMat}{a \code{big.matrix} object}
}
\description{
Returns the size of the created matrix in bytes
}
